// D import file generated from 'derelict/alure/alure.d'
module derelict.alure.alure;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ALURE32.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libalure.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libalure.so, libalure.so.1";
			}
			else
			{
				static assert(0, "Need to implement ALURE libNames for this operating system.");
			}
		}
	}
}
public import derelict.openal.al;

enum ALURE_VERSION_1_2 = true;
alias long alureInt64;
struct alureStream;
extern (C) 
{
	alias void* function(ALchar*) alureInstallDecodeCallbacks_open_file;
	alias void* function(ALubyte*, ALuint) alureInstallDecodeCallbacks_open_memory;
	alias ALboolean function(void*, ALenum*, ALuint*, ALuint*) alureInstallDecodeCallbacks_get_format;
	alias ALuint function(void*, ALubyte*, ALuint) alureInstallDecodeCallbacks_decode;
	alias ALboolean function(void*) alureInstallDecodeCallbacks_rewind;
	alias void function(void*) alureInstallDecodeCallbacks_close;
	alias ALuint function(void*, ALubyte*, ALuint) alureCreateStreamFromCallback_callback;
	alias void* function(char*, ALuint) alureSetIOCallbacks_open_callback;
	alias void function(char*) alureSetIOCallbacks_close_callback;
	alias ALsizei function(void*, ALubyte*, ALuint) alureSetIOCallbacks_read_callback;
	alias ALsizei function(void*, ALubyte*, ALuint) alureSetIOCallbacks_write_callback;
	alias alureInt64 function(void*, alureInt64, int) alureSetIOCallbacks_seek_callback;
	alias void function(void*, ALuint) alurePlaySourceStream_eos_callback;
	alias void function(void*, ALuint) alurePlaySource_callback;
}
extern (C) nothrow 
{
	alias void function(ALuint*, ALuint*) da_alureGetVersion;
	alias ALchar* function() da_alureGetErrorString;
	alias ALCchar** function(ALCboolean all, ALCsizei*) da_alureGetDeviceNames;
	alias void function(ALCchar**) da_alureFreeDeviceNames;
	alias ALCboolean function(ALCchar*, ALCint*) da_alureInitDevice;
	alias ALCboolean function() da_alureShutdownDevice;
	alias ALenum function(ALuint, ALuint, ALuint) da_alureGetSampleFormat;
	alias ALboolean function(ALint, alureInstallDecodeCallbacks_open_file, alureInstallDecodeCallbacks_open_memory, alureInstallDecodeCallbacks_get_format, alureInstallDecodeCallbacks_decode, alureInstallDecodeCallbacks_rewind, alureInstallDecodeCallbacks_close) da_alureInstallDecodeCallbacks;
	alias ALboolean function(ALfloat) da_alureSleep;
	alias void* function(ALchar*) da_alureGetProcAddress;
	alias ALuint function(ALchar*) da_alureCreateBufferFromFile;
	alias ALuint function(ALubyte*, ALsizei) da_alureCreateBufferFromMemory;
	alias ALboolean function(ALchar*, ALuint) da_alureBufferDataFromFile;
	alias ALboolean function(ALubyte*, ALsizei, ALuint) da_alureBufferDataFromMemory;
	alias ALboolean function(ALboolean) da_alureStreamSizeIsMicroSec;
	alias alureStream* function(ALchar*, ALsizei, ALsizei, ALuint*) da_alureCreateStreamFromFile;
	alias alureStream* function(ALubyte*, ALuint, ALsizei, ALsizei, ALuint*) da_alureCreateStreamFromMemory;
	alias alureStream* function(ALubyte*, ALuint, ALsizei, ALsizei, ALuint*) da_alureCreateStreamFromStaticMemory;
	alias alureStream* function(alureCreateStreamFromCallback_callback, void*, ALenum, ALuint, ALsizei, ALsizei, ALuint*) da_alureCreateStreamFromCallback;
	alias ALsizei function(alureStream*) da_alureGetStreamFrequency;
	alias ALsizei function(alureStream*, ALsizei, ALuint*) da_alureBufferDataFromStream;
	alias ALboolean function(alureStream*, ALsizei) da_alureRewindStream;
	alias ALboolean function(alureStream*, ALuint) da_alureSetStreamOrder;
	alias ALboolean function(alureStream*, ALchar*) da_alureSetStreamPatchset;
	alias alureInt64 function(alureStream*) da_alureGetStreamLength;
	alias ALboolean function(alureStream*, ALsizei, ALuint*) da_alureDestroyStream;
	alias ALboolean function(alureSetIOCallbacks_open_callback, alureSetIOCallbacks_close_callback, alureSetIOCallbacks_read_callback, alureSetIOCallbacks_write_callback, alureSetIOCallbacks_seek_callback) da_alureSetIOCallbacks;
	alias ALboolean function(ALuint, alureStream*, ALsizei, ALsizei, alurePlaySourceStream_eos_callback, void*) da_alurePlaySourceStream;
	alias ALboolean function(ALuint, alurePlaySource_callback, void*) da_alurePlaySource;
	alias ALboolean function(ALuint, ALboolean) da_alureStopSource;
	alias ALboolean function(ALuint) da_alurePauseSource;
	alias ALboolean function(ALuint) da_alureResumeSource;
	alias void function() da_alureUpdate;
	alias ALboolean function(ALfloat) da_alureUpdateInterval;
}

__gshared 
{
	da_alureGetVersion alureGetVersion;
	da_alureGetErrorString alureGetErrorString;
	da_alureGetDeviceNames alureGetDeviceNames;
	da_alureFreeDeviceNames alureFreeDeviceNames;
	da_alureInitDevice alureInitDevice;
	da_alureShutdownDevice alureShutdownDevice;
	da_alureGetSampleFormat alureGetSampleFormat;
	da_alureInstallDecodeCallbacks alureInstallDecodeCallbacks;
	da_alureSleep alureSleep;
	da_alureGetProcAddress alureGetProcAddress;
	da_alureCreateBufferFromFile alureCreateBufferFromFile;
	da_alureCreateBufferFromMemory alureCreateBufferFromMemory;
	da_alureBufferDataFromFile alureBufferDataFromFile;
	da_alureBufferDataFromMemory alureBufferDataFromMemory;
	da_alureStreamSizeIsMicroSec alureStreamSizeIsMicroSec;
	da_alureCreateStreamFromFile alureCreateStreamFromFile;
	da_alureCreateStreamFromMemory alureCreateStreamFromMemory;
	da_alureCreateStreamFromStaticMemory alureCreateStreamFromStaticMemory;
	da_alureCreateStreamFromCallback alureCreateStreamFromCallback;
	da_alureGetStreamFrequency alureGetStreamFrequency;
	da_alureBufferDataFromStream alureBufferDataFromStream;
	da_alureRewindStream alureRewindStream;
	da_alureSetStreamOrder alureSetStreamOrder;
	da_alureSetStreamPatchset alureSetStreamPatchset;
	da_alureGetStreamLength alureGetStreamLength;
	da_alureDestroyStream alureDestroyStream;
	da_alureSetIOCallbacks alureSetIOCallbacks;
	da_alurePlaySourceStream alurePlaySourceStream;
	da_alurePlaySource alurePlaySource;
	da_alureStopSource alureStopSource;
	da_alurePauseSource alurePauseSource;
	da_alureResumeSource alureResumeSource;
	da_alureUpdate alureUpdate;
	da_alureUpdateInterval alureUpdateInterval;
}
class DerelictALURELoader : SharedLibLoader
{
	protected override void loadSymbols();


	public this();

}
__gshared DerelictALURELoader DerelictALURE;

shared static this();
