// D import file generated from 'derelict/ode/types.d'
module derelict.ode.types;
private 
{
	import std.math;
	import core.vararg;
	import core.stdc.config;
}
alias int int32;
alias uint uint32;
alias short int16;
alias ushort uint16;
alias byte int8;
alias ubyte uint8;
version (DerelictODE_DoublePrecision)
{
	enum dInfinity = (double).infinity;
}
else
{
	enum dInfinity = (float).infinity;
}
version (DerelictODE_DoublePrecision)
{
	alias double dReal;
}
else
{
	alias float dReal;
}
alias PI M_PI;
alias SQRT1_2 M_SQRT1_2;
version (DerelictOde_TriMesh_16Bit_Indices)
{
	version (DerelictOde_TriMesh_GIMPACT)
	{
		alias uint32 dTriIndex;
	}
	else
	{
		alias uint16 dTriIndex;
	}
}
else
{
	alias uint32 dTriIndex;
}
int dPAD(int a);
alias dReal[4] dVector3;
alias dReal[4] dVector4;
alias dReal[4 * 3] dMatrix3;
alias dReal[4 * 4] dMatrix4;
alias dReal[8 * 6] dMatrix6;
alias dReal[4] dQuaternion;
dReal dRecip(dReal x);
dReal dRecipSqrt(dReal x);
dReal dFMod(dReal a, dReal b);
alias sqrt dSqrt;
alias sin dSin;
alias cos dCos;
alias fabs dFabs;
alias atan2 dAtan2;
alias isnan dIsNan;
alias copysign dCopySign;
alias floor dFloor;
alias ceil dCeil;
alias nextafter dNextAfter;
struct dxWorld;
struct dxSpace;
struct dxBody;
struct dxGeom;
struct dxJoint;
struct dxJointNode;
struct dxJointGroup;
struct dxWorldProcessThreadingManager;
alias dxWorld* dWorldID;
alias dxSpace* dSpaceID;
alias dxBody* dBodyID;
alias dxGeom* dGeomID;
alias dxJoint* dJointID;
alias dxJointGroup* dJointGroupID;
alias dxWorldProcessThreadingManager* dWorldStepThreadingManagerId;
enum 
{
	d_ERR_UNKNOWN = 0,
	d_ERR_IASSERT,
	d_ERR_UASSERT,
	d_ERR_LCP,
}
alias int dJointType;
enum 
{
	dJointTypeNone = 0,
	dJointTypeBall,
	dJointTypeHinge,
	dJointTypeSlider,
	dJointTypeContact,
	dJointTypeUniversal,
	dJointTypeHinge2,
	dJointTypeFixed,
	dJointTypeNull,
	dJointTypeAMotor,
	dJointTypeLMotor,
	dJointTypePlane2D,
	dJointTypePR,
	dJointTypePU,
	dJointTypePiston,
}
enum 
{
	dParamLoStop = 0,
	dParamHiStop,
	dParamVel,
	dParamFMax,
	dParamFudgeFactor,
	dParamBounce,
	dParamCFM,
	dParamStopERP,
	dParamStopCFM,
	dParamSuspensionERP,
	dParamSuspensionCFM,
	dParamERP,
	dParamsInGroup,
	dParamLoStop1 = 0,
	dParamHiStop1,
	dParamVel1,
	dParamFMax1,
	dParamFudgeFactor1,
	dParamBounce1,
	dParamCFM1,
	dParamStopERP1,
	dParamStopCFM1,
	dParamSuspensionERP1,
	dParamSuspensionCFM1,
	dParamERP1,
	dParamLoStop2 = 256,
	dParamHiStop2,
	dParamVel2,
	dParamFMax2,
	dParamFudgeFactor2,
	dParamBounce2,
	dParamCFM2,
	dParamStopERP2,
	dParamStopCFM2,
	dParamSuspensionERP2,
	dParamSuspensionCFM2,
	dParamERP2,
	dParamLoStop3 = 512,
	dParamHiStop3,
	dParamVel3,
	dParamFMax3,
	dParamFudgeFactor3,
	dParamBounce3,
	dParamCFM3,
	dParamStopERP3,
	dParamStopCFM3,
	dParamSuspensionERP3,
	dParamSuspensionCFM3,
	dParamERP3,
	dParamGroup = 256,
}
enum 
{
	dAMotorUser = 0,
	dAMotorEuler = 1,
}
struct dJointFeedback
{
	dVector3 f1;
	dVector3 t1;
	dVector3 f2;
	dVector3 t2;
}
enum 
{
	dGeomCommonControlClass = 0,
	dGeomColliderControlClass = 1,
}
enum 
{
	dGeomCommonAnyControlCode = 0,
	dGeomColliderSetMergeSphereContactsControlCode = 1,
	dGeomColliderGetMergeSphereContactsControlCode = 2,
}
enum 
{
	dGeomColliderMergeContactsValue__Default = 0,
	dGeomColliderMergeContactsValue_None = 1,
	dGeomColliderMergeContactsValue_Normals = 2,
	dGeomColliderMergeContactsValue_Full = 3,
}
enum 
{
	CONTACTS_UNIMPORTANT = 2147483648u,
}
enum 
{
	dMaxUserClasses = 4,
}
enum 
{
	dSphereClass = 0,
	dBoxClass,
	dCapsuleClass,
	dCylinderClass,
	dPlaneClass,
	dRayClass,
	dConvexClass,
	dGeomTransformClass,
	dTriMeshClass,
	dHeightFieldClass,
	dFirstSpaceClass,
	dSimpleSpaceClass = dFirstSpaceClass,
	dHashSpaceClass,
	dSweepAndPruneSpaceClass,
	dQuadTreeClass,
	dLastSpaceClass = dQuadTreeClass,
	dFirstUserClass,
	dLastUserClass = dFirstUserClass + dMaxUserClasses - 1,
	dGeomNumClasses,
}
alias dCapsuleClass dCCylinderClass;
struct dxHeightfieldData;
alias dxHeightfieldData* dHeightfieldDataID;
extern (C) nothrow 
{
	alias dReal function(void*, int, int) dHeightfieldGetHeight;
	alias void function(dGeomID, ref dReal[6]) dGetAABBFn;
	alias int function(dGeomID, dGeomID, int, dContactGeom*, int) dColliderFn;
	alias dColliderFn function(int) dGetColliderFnFn;
	alias void function(dGeomID) dGeomDtorFn;
	alias int function(dGeomID, dGeomID, ref dReal[6]) dAABBTestFn;
}

struct dGeomClass
{
	int bytes;
	dGetColliderFnFn collider;
	dGetAABBFn aabb;
	dAABBTestFn aabb_test;
	dGeomDtorFn dtor;
}
extern (C) nothrow alias void function(void*, dGeomID, dGeomID) dNearCallback;


enum 
{
	dSAP_AXES_XYZ = 0 | 1 << 2 | 2 << 4,
	dSAP_AXES_XZY = 0 | 2 << 2 | 1 << 4,
	dSAP_AXES_YXZ = 1 | 0 << 2 | 2 << 4,
	dSAP_AXES_YZX = 1 | 2 << 2 | 0 << 4,
	dSAP_AXES_ZXY = 2 | 0 << 2 | 1 << 4,
	dSAP_AXES_ZYX = 2 | 1 << 2 | 0 << 4,
}
struct dxTriMeshData;
alias dxTriMeshData* dTriMeshDataID;
enum 
{
	TRIMESH_FACE_NORMALS,
}
extern (C) nothrow 
{
	alias int function(dGeomID, dGeomID, int) dTriCallback;
	alias void function(dGeomID, dGeomID, in int*, int) dTriArrayCallback;
	alias int function(dGeomID, dGeomID, int, dReal, dReal) dTriRayCallback;
	alias int function(dGeomID, int, int) dTriTriMergeCallback;
}

enum 
{
	dContactMu2 = 1,
	dContactFDir1 = 2,
	dContactBounce = 4,
	dContactSoftERP = 8,
	dContactSoftCFM = 16,
	dContactMotion1 = 32,
	dContactMotion2 = 64,
	dContactMotionN = 128,
	dContactSlip1 = 256,
	dContactSlip2 = 512,
	dContactApprox0 = 0,
	dContactApprox1_1 = 4096,
	dContactApprox1_2 = 8192,
	dContactApprox1 = 12288,
}
struct dSurfaceParameters
{
	int mode;
	dReal mu;
	dReal mu2;
	dReal bounce;
	dReal bounce_vel;
	dReal soft_erp;
	dReal soft_cfm;
	dReal motion1;
	dReal motion2;
	dReal motionN;
	dReal slip1;
	dReal slip2;
}
struct dContactGeom
{
	dVector3 pos;
	dVector3 normal;
	dReal depth;
	dGeomID g1;
	dGeomID g2;
	int side1;
	int side2;
}
struct dContact
{
	dSurfaceParameters surface;
	dContactGeom geom;
	dVector3 fdir1;
}
extern (C) nothrow alias void function(int, const(char)*, va_list ap) dMessageFunction;


struct dMass
{
	dReal mass;
	dVector3 c;
	dMatrix3 I;
}
extern (C) nothrow 
{
	alias void* function(size_t) dAllocFunction;
	alias void* function(void*, size_t, size_t) dReallocFunction;
	alias void function(void*, size_t) dFreeFunction;
}

enum dWORLDSTEP_RESERVEFACTOR_DEFAULT = 1.2F;
enum dWORLDSTEP_RESERVESIZE_DEFAULT = 65536u;
struct dWorldStepReserveInfo
{
	uint struct_size;
	float reserve_factor;
	uint reserve_minimum;
}
struct dWorldStepMemoryFunctionsInfo
{
	uint struct_size;
	extern (C) nothrow 
	{
		void* function(size_t) alloc_block;
		void* function(void*, size_t, size_t) shrink_block;
		void function(void*, size_t) free_block;
	}

}
enum : uint
{
	dInitFlagManualThreadCleanup = 1,
}
enum : uint
{
	dAllocateFlagsBasicData = 0,
	dAllocateFlagsCollisionData = 1,
	dAllocateMaskAll = ~0u,
}
template dACCESS33(T)
{
	auto dACCESS33(T a, size_t i, size_t j)
	{
		return a[i * 4 + j];
	}

}
template dVALIDVEC3(T)
{
	bool dVALIDVEC3(T v)
	{
		return !(dIsNan(v[0]) || dIsNan(v[1]) || dIsNan(v[2]));
	}

}
template dVALIDVEC4(T)
{
	bool dVALIDVEC4(T v)
	{
		return !(dIsNan(v[0]) || dIsNan(v[1]) || dIsNan(v[2]) || dIsNan(v[3]));
	}

}
template dVALIDMAT3(T)
{
	bool dVALIDMAT3(T m)
	{
		return !(dIsNan(m[0]) || dIsNan(m[1]) || dIsNan(m[2]) || dIsNan(m[3]) || dIsNan(m[4]) || dIsNan(m[5]) || dIsNan(m[6]) || dIsNan(m[7]) || dIsNan(m[8]) || dIsNan(m[9]) || dIsNan(m[10]) || dIsNan(m[11]));
	}

}
template dVALIDMAT4(T)
{
	bool dVALIDMAT4(T m)
	{
		return !(dIsNan(m[0]) || dIsNan(m[1]) || dIsNan(m[2]) || dIsNan(m[3]) || dIsNan(m[4]) || dIsNan(m[5]) || dIsNan(m[6]) || dIsNan(m[7]) || dIsNan(m[8]) || dIsNan(m[9]) || dIsNan(m[10]) || dIsNan(m[11]) || dIsNan(m[12]) || dIsNan(m[13]) || dIsNan(m[14]) || dIsNan(m[15]));
	}

}
void dAddVectors3(dReal* res, in dReal* a, in dReal* b);
void dSubtractVectors3(dReal* res, in dReal* a, in dReal* b);
void dAddScaledVectors3(dReal* res, in dReal* a, in dReal* b, dReal a_scale, dReal b_scale);
void dScaleVector3(dReal* res, dReal nScale);
void dNegateVector3(dReal* res);
void dCopyVector3(dReal* res, in dReal* a);
void dCopyScaledVector3(dReal* res, in dReal* a, dReal nScale);
void dCopyNegatedVector3(dReal* res, in dReal* a);
void dCopyVector4(dReal* res, in dReal* a);
void dCopyMatrix4x4(dReal* res, in dReal* a);
void dCopyMatrix4x3(dReal* res, in dReal* a);
void dGetMatrixColumn3(dReal* res, in dReal* a, uint n);
dReal dCalcVectorLength3(in dReal* a);
dReal dCalcVectorLengthSquare3(in dReal* a);
dReal dCalcPointDepth3(in dReal* test_p, in dReal* plane_p, in dReal* plane_n);
dReal _dCalcVectorDot3(in dReal* a, in dReal* b, uint step_a, uint step_b);
dReal dCalcVectorDot3(in dReal* a, in dReal* b);
dReal dCalcVectorDot3_13(in dReal* a, in dReal* b);
dReal dCalcVectorDot3_31(in dReal* a, in dReal* b);
dReal dCalcVectorDot3_33(in dReal* a, in dReal* b);
dReal dCalcVectorDot3_14(in dReal* a, in dReal* b);
dReal dCalcVectorDot3_41(in dReal* a, in dReal* b);
dReal dCalcVectorDot3_44(in dReal* a, in dReal* b);
void _dCalcVectorCross3(dReal* res, in dReal* a, in dReal* b, uint step_res, uint step_a, uint step_b);
void dCalcVectorCross3(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_114(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_141(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_144(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_411(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_414(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_441(dReal* res, in dReal* a, in dReal* b);
void dCalcVectorCross3_444(dReal* res, in dReal* a, in dReal* b);
void dAddVectorCross3(dReal* res, in dReal* a, in dReal* b);
void dSubtractVectorCross3(dReal* res, in dReal* a, in dReal* b);
void dSetCrossMatrixPlus(dReal* res, in dReal* a, uint skip);
void dSetCrossMatrixMinus(dReal* res, in dReal* a, uint skip);
dReal dCalcPointsDistance3(in dReal* a, in dReal* b);
void dMultiplyHelper0_331(dReal* res, in dReal* a, in dReal* b);
void dMultiplyHelper1_331(dReal* res, in dReal* a, in dReal* b);
void dMultiplyHelper0_133(dReal* res, in dReal* a, in dReal* b);
void dMultiplyHelper1_133(dReal* res, in dReal* a, in dReal* b);
void dMultiply0_331(dReal* res, in dReal* a, in dReal* b);
void dMultiply1_331(dReal* res, in dReal* a, in dReal* b);
void dMultiply0_133(dReal* res, in dReal* a, in dReal* b);
void dMultiply0_333(dReal* res, in dReal* a, in dReal* b);
void dMultiply1_333(dReal* res, in dReal* a, in dReal* b);
void dMultiply2_333(dReal* res, in dReal* a, in dReal* b);
void dMultiplyAdd0_331(dReal* res, in dReal* a, in dReal* b);
void dMultiplyAdd1_331(dReal* res, in dReal* a, in dReal* b);
void dMultiplyAdd0_133(dReal* res, in dReal* a, in dReal* b);
void dMultiplyAdd0_333(dReal* res, in dReal* a, in dReal* b);
void dMultiplyAdd1_333(dReal* res, in dReal* a, in dReal* b);
void dMultiplyAdd2_333(dReal* res, in dReal* a, in dReal* b);
struct dStopwatch
{
	double time;
	c_ulong[2] cc;
}
