// D import file generated from 'derelict/ogg/ogg.d'
module derelict.ogg.ogg;
private 
{
	import core.stdc.config;
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ogg.dll, libogg-0.dll, libogg.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libogg.dylib, libogg.0.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libogg.so, libogg.so.0";
			}
			else
			{
				static assert(0, "Need to implement libogg libnames for this operating system.");
			}
		}
	}
}
alias long ogg_int64_t;
alias ulong ogg_uint64_t;
alias int ogg_int32_t;
alias uint ogg_uint32_t;
alias short ogg_int16_t;
alias ushort ogg_uint16_t;
struct ogg_iovec_t
{
	void* iov_base;
	size_t iov_len;
}
struct oggpack_buffer
{
	c_long endbyte;
	int endbit;
	ubyte* buffer;
	ubyte* ptr;
	c_long storage;
}
struct ogg_page
{
	ubyte* header;
	c_long header_len;
	ubyte* _body;
	c_long body_len;
}
struct ogg_stream_state
{
	ubyte* body_data;
	c_long body_storage;
	c_long body_fill;
	c_long body_returned;
	int* lacing_vals;
	ogg_int64_t* granule_vals;
	c_long lacing_storage;
	c_long lacing_fill;
	c_long lacing_packet;
	c_long lacing_returned;
	ubyte[282] header;
	int header_fill;
	int e_o_s;
	int b_o_s;
	c_long serialno;
	c_long pageno;
	ogg_int64_t packetno;
	ogg_int64_t granulepos;
}
struct ogg_packet
{
	ubyte* packet;
	c_long bytes;
	c_long b_o_s;
	c_long e_o_s;
	ogg_int64_t granulepos;
	ogg_int64_t packetno;
}
struct ogg_sync_state
{
	ubyte* data;
	int storage;
	int fill;
	int returned;
	int unsynced;
	int headerbytes;
	int bodybytes;
}
extern (C) nothrow 
{
	alias void function(oggpack_buffer*) da_oggpack_writeinit;
	alias void function(oggpack_buffer*) da_oggpack_writecheck;
	alias void function(oggpack_buffer*, c_long) da_oggpack_writetrunc;
	alias void function(oggpack_buffer*) da_oggpack_writealign;
	alias void function(oggpack_buffer*, void*, c_long) da_oggpack_writecopy;
	alias void function(oggpack_buffer*) da_oggpack_reset;
	alias void function(oggpack_buffer*) da_oggpack_writeclear;
	alias void function(oggpack_buffer*, ubyte*, int) da_oggpack_readinit;
	alias void function(oggpack_buffer*, c_ulong, int) da_oggpack_write;
	alias c_long function(oggpack_buffer*, int) da_oggpack_look;
	alias c_long function(oggpack_buffer*) da_oggpack_look1;
	alias void function(oggpack_buffer*, int) da_oggpack_adv;
	alias void function(oggpack_buffer*) da_oggpack_adv1;
	alias c_long function(oggpack_buffer*, int) da_oggpack_read;
	alias c_long function(oggpack_buffer*) da_oggpack_read1;
	alias c_long function(oggpack_buffer*) da_oggpack_bytes;
	alias c_long function(oggpack_buffer*) da_oggpack_bits;
	alias ubyte function(oggpack_buffer*) da_oggpack_get_buffer;
	alias void function(oggpack_buffer*) da_oggpackB_writeinit;
	alias void function(oggpack_buffer*) da_oggpackB_writecheck;
	alias void function(oggpack_buffer*, c_long) da_oggpackB_writetrunc;
	alias void function(oggpack_buffer*) da_oggpackB_writealign;
	alias void function(oggpack_buffer*, void*, c_long) da_oggpackB_writecopy;
	alias void function(oggpack_buffer*) da_oggpackB_reset;
	alias void function(oggpack_buffer*) da_oggpackB_writeclear;
	alias void function(oggpack_buffer*, ubyte*, int) da_oggpackB_readinit;
	alias void function(oggpack_buffer*, uint, c_long) da_oggpackB_write;
	alias c_long function(oggpack_buffer*, int) da_oggpackB_look;
	alias c_long function(oggpack_buffer*) da_oggpackB_look1;
	alias void function(oggpack_buffer*, int) da_oggpackB_adv;
	alias void function(oggpack_buffer*) da_oggpackB_adv1;
	alias c_long function(oggpack_buffer*, int) da_oggpackB_read;
	alias c_long function(oggpack_buffer*) da_oggpackB_read1;
	alias c_long function(oggpack_buffer*) da_oggpackB_bytes;
	alias c_long function(oggpack_buffer*) da_oggpackB_bits;
	alias ubyte function(oggpack_buffer*) da_oggpackB_get_buffer;
	alias int function(ogg_stream_state*, ogg_packet*) da_ogg_stream_packetin;
	alias int function(ogg_stream_state*, ogg_iovec_t*, int, c_long, ogg_int64_t) da_ogg_stream_iovecin;
	alias int function(ogg_stream_state*, ogg_page*) da_ogg_stream_pageout;
	alias int function(ogg_stream_state*, ogg_page*, int) da_ogg_stream_pageout_fill;
	alias int function(ogg_stream_state*, ogg_page*) da_ogg_stream_flush;
	alias int function(ogg_stream_state*, ogg_page*) da_ogg_stream_flush_fill;
	alias int function(ogg_sync_state*) da_ogg_sync_init;
	alias int function(ogg_sync_state*) da_ogg_sync_clear;
	alias int function(ogg_sync_state*) da_ogg_sync_reset;
	alias int function(ogg_sync_state*) da_ogg_sync_destroy;
	alias int function(ogg_sync_state*) da_ogg_sync_check;
	alias byte* function(ogg_sync_state*, c_long) da_ogg_sync_buffer;
	alias int function(ogg_sync_state*, c_long) da_ogg_sync_wrote;
	alias c_long function(ogg_sync_state*, ogg_page*) da_ogg_sync_pageseek;
	alias int function(ogg_sync_state*, ogg_page*) da_ogg_sync_pageout;
	alias int function(ogg_stream_state*, ogg_page*) da_ogg_stream_pagein;
	alias int function(ogg_stream_state*, ogg_packet*) da_ogg_stream_packetout;
	alias int function(ogg_stream_state*, ogg_packet*) da_ogg_stream_packetpeek;
	alias int function(ogg_stream_state*, int serialno) da_ogg_stream_init;
	alias int function(ogg_stream_state*) da_ogg_stream_clear;
	alias int function(ogg_stream_state*) da_ogg_stream_reset;
	alias int function(ogg_stream_state*, int serialno) da_ogg_stream_reset_serialno;
	alias int function(ogg_stream_state*) da_ogg_stream_destroy;
	alias int function(ogg_stream_state*) da_ogg_stream_check;
	alias int function(ogg_stream_state*) da_ogg_stream_eos;
	alias void function(ogg_page*) da_ogg_page_checksum_set;
	alias int function(ogg_page*) da_ogg_page_version;
	alias int function(ogg_page*) da_ogg_page_continued;
	alias int function(ogg_page*) da_ogg_page_bos;
	alias int function(ogg_page*) da_ogg_page_eos;
	alias ogg_int64_t function(ogg_page*) da_ogg_page_granulepos;
	alias int function(ogg_page*) da_ogg_page_serialno;
	alias c_long function(ogg_page*) da_ogg_page_pageno;
	alias int function(ogg_page*) da_ogg_page_packets;
	alias void function(ogg_packet*) da_ogg_packet_clear;
}

__gshared 
{
	da_oggpack_writeinit oggpack_writeinit;
	da_oggpack_writecheck oggpack_writecheck;
	da_oggpack_writetrunc oggpack_writetrunc;
	da_oggpack_writealign oggpack_writealign;
	da_oggpack_writecopy oggpack_writecopy;
	da_oggpack_reset oggpack_reset;
	da_oggpack_writeclear oggpack_writeclear;
	da_oggpack_readinit oggpack_readinit;
	da_oggpack_write oggpack_write;
	da_oggpack_look oggpack_look;
	da_oggpack_look1 oggpack_look1;
	da_oggpack_adv oggpack_adv;
	da_oggpack_adv1 oggpack_adv1;
	da_oggpack_read oggpack_read;
	da_oggpack_read1 oggpack_read1;
	da_oggpack_bytes oggpack_bytes;
	da_oggpack_bits oggpack_bits;
	da_oggpack_get_buffer oggpack_get_buffer;
	da_oggpackB_writeinit oggpackB_writeinit;
	da_oggpackB_writecheck oggpackB_writecheck;
	da_oggpackB_writetrunc oggpackB_writetrunc;
	da_oggpackB_writealign oggpackB_writealign;
	da_oggpackB_writecopy oggpackB_writecopy;
	da_oggpackB_reset oggpackB_reset;
	da_oggpackB_writeclear oggpackB_writeclear;
	da_oggpackB_readinit oggpackB_readinit;
	da_oggpackB_write oggpackB_write;
	da_oggpackB_look oggpackB_look;
	da_oggpackB_look1 oggpackB_look1;
	da_oggpackB_adv oggpackB_adv;
	da_oggpackB_adv1 oggpackB_adv1;
	da_oggpackB_read oggpackB_read;
	da_oggpackB_read1 oggpackB_read1;
	da_oggpackB_bytes oggpackB_bytes;
	da_oggpackB_bits oggpackB_bits;
	da_oggpackB_get_buffer oggpackB_get_buffer;
	da_ogg_stream_packetin ogg_stream_packetin;
	da_ogg_stream_iovecin ogg_stream_iovecin;
	da_ogg_stream_pageout ogg_stream_pageout;
	da_ogg_stream_pageout_fill ogg_stream_pageout_fill;
	da_ogg_stream_flush ogg_stream_flush;
	da_ogg_stream_flush_fill ogg_stream_flush_fill;
	da_ogg_sync_init ogg_sync_init;
	da_ogg_sync_clear ogg_sync_clear;
	da_ogg_sync_reset ogg_sync_reset;
	da_ogg_sync_destroy ogg_sync_destroy;
	da_ogg_sync_check ogg_sync_check;
	da_ogg_sync_buffer ogg_sync_buffer;
	da_ogg_sync_wrote ogg_sync_wrote;
	da_ogg_sync_pageseek ogg_sync_pageseek;
	da_ogg_sync_pageout ogg_sync_pageout;
	da_ogg_stream_pagein ogg_stream_pagein;
	da_ogg_stream_packetout ogg_stream_packetout;
	da_ogg_stream_packetpeek ogg_stream_packetpeek;
	da_ogg_stream_init ogg_stream_init;
	da_ogg_stream_clear ogg_stream_clear;
	da_ogg_stream_reset ogg_stream_reset;
	da_ogg_stream_reset_serialno ogg_stream_reset_serialno;
	da_ogg_stream_destroy ogg_stream_destroy;
	da_ogg_stream_check ogg_stream_check;
	da_ogg_stream_eos ogg_stream_eos;
	da_ogg_page_checksum_set ogg_page_checksum_set;
	da_ogg_page_version ogg_page_version;
	da_ogg_page_continued ogg_page_continued;
	da_ogg_page_bos ogg_page_bos;
	da_ogg_page_eos ogg_page_eos;
	da_ogg_page_granulepos ogg_page_granulepos;
	da_ogg_page_serialno ogg_page_serialno;
	da_ogg_page_pageno ogg_page_pageno;
	da_ogg_page_packets ogg_page_packets;
	da_ogg_packet_clear ogg_packet_clear;
}
class DerelictOggLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();


}
__gshared DerelictOggLoader DerelictOgg;

shared static this();
