// D import file generated from 'derelict/openal/al.d'
module derelict.openal.al;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "OpenAl32.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "../Frameworks/OpenAL.framework/OpenAL, /Library/Frameworks/OpenAL.framework/OpenAL, /System/Library/Frameworks/OpenAL.framework/OpenAL";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libal.so, libAL.so, libopenal.so, libopenal.so.1, libopenal.so.0";
			}
			else
			{
				static assert(0, "Need to implement OpenAL libNames for this operating system.");
			}
		}
	}
}
enum AL_VERSION_1_0 = true;
enum AL_VERSION_1_1 = true;
alias byte ALboolean;
alias char ALchar;
alias byte ALbyte;
alias ubyte ALubyte;
alias short ALshort;
alias ushort ALushort;
alias int ALint;
alias uint ALuint;
alias int ALsizei;
alias int ALenum;
alias float ALfloat;
alias double ALdouble;
alias void ALvoid;
enum : ALboolean
{
	AL_FALSE = 0,
	AL_TRUE = 1,
}
enum : ALenum
{
	AL_INVALID = -1,
	AL_NONE = 0,
	AL_SOURCE_RELATIVE = 514,
	AL_CONE_INNER_ANGLE = 4097,
	AL_CONE_OUTER_ANGLE = 4098,
	AL_PITCH = 4099,
	AL_POSITION = 4100,
	AL_DIRECTION = 4101,
	AL_VELOCITY = 4102,
	AL_LOOPING = 4103,
	AL_BUFFER = 4105,
	AL_GAIN = 4106,
	AL_MIN_GAIN = 4109,
	AL_MAX_GAIN = 4110,
	AL_ORIENTATION = 4111,
	AL_CHANNEL_MASK = 12288,
	AL_SOURCE_STATE = 4112,
	AL_INITIAL = 4113,
	AL_PLAYING = 4114,
	AL_PAUSED = 4115,
	AL_STOPPED = 4116,
	AL_BUFFERS_QUEUED = 4117,
	AL_BUFFERS_PROCESSED = 4118,
	AL_REFERENCE_DISTANCE = 4128,
	AL_ROLLOFF_FACTOR = 4129,
	AL_CONE_OUTER_GAIN = 4130,
	AL_MAX_DISTANCE = 4131,
	AL_SEC_OFFSET = 4132,
	AL_SAMPLE_OFFSET = 4133,
	AL_BYTE_OFFSET = 4134,
	AL_SOURCE_TYPE = 4135,
	AL_STATIC = 4136,
	AL_STREAMING = 4137,
	AL_UNDETERMINED = 4144,
	AL_FORMAT_MONO8 = 4352,
	AL_FORMAT_MONO16 = 4353,
	AL_FORMAT_STEREO8 = 4354,
	AL_FORMAT_STEREO16 = 4355,
	AL_FREQUENCEY = 8193,
	AL_BITS = 8194,
	AL_CHANNELS = 8195,
	AL_SIZE = 8196,
	AL_UNUSED = 8208,
	AL_PENDING = 8209,
	AL_PROCESSID = 8210,
	AL_NO_ERROR = AL_FALSE,
	AL_INVALID_NAME = 40961,
	AL_INVALID_ENUM = 40962,
	AL_INVALID_VALUE = 40963,
	AL_INVALID_OPERATION = 40964,
	AL_OUT_OF_MEMORY = 40965,
	AL_VENDOR = 45057,
	AL_VERSION = 45058,
	AL_RENDERER = 45059,
	AL_EXTENSIONS = 45060,
	AL_DOPPLER_FACTOR = 49152,
	AL_DOPPLER_VELOCITY = 49153,
	AL_SPEED_OF_SOUND = 49155,
	AL_DISTANCE_MODEL = 53248,
	AL_INVERSE_DISTANCE = 53249,
	AL_INVERSE_DISTANCE_CLAMPED = 53250,
	AL_LINEAR_DISTANCE = 53251,
	AL_LINEAR_DISTANCE_CLAMPED = 53252,
	AL_EXPONENT_DISTANCE = 53253,
	AL_EXPONENT_DISTANCE_CLAMPED = 53254,
}
enum ALC_VERSION_0_1 = true;
alias void ALCdevice;
alias void ALCcontext;
alias byte ALCboolean;
alias char ALCchar;
alias byte ALCbyte;
alias ubyte ALCubyte;
alias short ALCshort;
alias ushort ALCushort;
alias int ALCint;
alias uint ALCuint;
alias int ALCsizei;
alias int ALCenum;
alias float ALCfloat;
alias double ALCdouble;
alias void ALCvoid;
enum : ALCboolean
{
	ALC_FALSE = 0,
	ALC_TRUE = 1,
}
enum : ALCenum
{
	ALC_FREQUENCY = 4103,
	ALC_REFRESH = 4104,
	ALC_SYNC = 4105,
	ALC_MONO_SOURCES = 4112,
	ALC_STEREO_SOURCES = 4113,
	ALC_NO_ERROR = ALC_FALSE,
	ALC_INVALID_DEVICE = 40961,
	ALC_INVALID_CONTEXT = 40962,
	ALC_INVALID_ENUM = 40963,
	ALC_INVALID_VALUE = 40964,
	ALC_OUT_OF_MEMORY = 40965,
	ALC_DEFAULT_DEVICE_SPECIFIER = 4100,
	ALC_DEVICE_SPECIFIER = 4101,
	ALC_EXTENSIONS = 4102,
	ALC_MAJOR_VERSION = 4096,
	ALC_MINOR_VERSION = 4097,
	ALC_ATTRIBUTES_SIZE = 4098,
	ALC_ALL_ATTRIBUTES = 4099,
	ALC_CAPTURE_DEVICE_SPECIFIER = 784,
	ALC_CAPTURE_DEFAULT_DEVICE_SPECIFIER = 785,
	ALC_CAPTURE_SAMPLES = 786,
}
enum : ALenum
{
	AL_FORMAT_IMA_ADPCM_MONO16_EXT = 65536,
	AL_FORMAT_IMA_ADPCM_STEREO16_EXT = 65537,
	AL_FORMAT_WAVE_EXT = 65538,
	AL_FORMAT_VORBIS_EXT = 65539,
	AL_FORMAT_QUAD8_LOKI = 65540,
	AL_FORMAT_QUAD16_LOKI = 65541,
	AL_FORMAT_MONO_FLOAT32 = 65552,
	AL_FORMAT_STEREO_FLOAT32 = 65553,
	ALC_CHAN_MAIN_LOKI = 5242881,
	ALC_CHAN_PCM_LOKI = 5242882,
	ALC_CHAN_CD_LOKI = 5242883,
	ALC_DEFAULT_ALL_DEVICES_SPECIFIER = 4114,
	ALC_ALL_DEVICES_SPECIFIER = 4115,
	AL_FORMAT_QUAD8 = 4612,
	AL_FORMAT_QUAD16 = 4613,
	AL_FORMAT_QUAD32 = 4614,
	AL_FORMAT_REAR8 = 4615,
	AL_FORMAT_REAR16 = 4616,
	AL_FORMAT_REAR32 = 4617,
	AL_FORMAT_51CHN8 = 4618,
	AL_FORMAT_51CHN16 = 4619,
	AL_FORMAT_51CHN32 = 4620,
	AL_FORMAT_61CHN8 = 4621,
	AL_FORMAT_61CHN16 = 4622,
	AL_FORMAT_61CHN32 = 4623,
	AL_FORMAT_71CHN8 = 4624,
	AL_FORMAT_71CHN16 = 4625,
	AL_FORMAT_71CHN32 = 4626,
	AL_FORMAT_MONO_IMA4 = 4864,
	AL_FORMAT_STEREO_IMA4 = 4865,
}
extern (C) nothrow 
{
	alias void function(ALenum) da_alEnable;
	alias void function(ALenum) da_alDisable;
	alias ALboolean function(ALenum) da_alIsEnabled;
	alias const(ALchar)* function(ALenum) da_alGetString;
	alias void function(ALenum, ALboolean*) da_alGetBooleanv;
	alias void function(ALenum, ALint*) da_alGetIntegerv;
	alias void function(ALenum, ALfloat*) da_alGetFloatv;
	alias void function(ALenum, ALdouble*) da_alGetDoublev;
	alias ALboolean function(ALenum) da_alGetBoolean;
	alias ALint function(ALenum) da_alGetInteger;
	alias ALfloat function(ALenum) da_alGetFloat;
	alias ALdouble function(ALenum) da_alGetDouble;
	alias ALenum function() da_alGetError;
	alias ALboolean function(const(char)*) da_alIsExtensionPresent;
	alias ALvoid* function(const(char)*) da_alGetProcAddress;
	alias ALenum function(const(char)*) da_alGetEnumValue;
	alias void function(ALenum, ALfloat) da_alListenerf;
	alias void function(ALenum, ALfloat, ALfloat, ALfloat) da_alListener3f;
	alias void function(ALenum, const(ALfloat)*) da_alListenerfv;
	alias void function(ALenum, ALint) da_alListeneri;
	alias void function(ALenum, ALint, ALint, ALint) da_alListener3i;
	alias void function(ALenum, const(ALint)*) da_alListeneriv;
	alias void function(ALenum, ALfloat*) da_alGetListenerf;
	alias void function(ALenum, ALfloat*, ALfloat*, ALfloat*) da_alGetListener3f;
	alias void function(ALenum, ALfloat*) da_alGetListenerfv;
	alias void function(ALenum, ALint*) da_alGetListeneri;
	alias void function(ALenum, ALint*, ALint*, ALint*) da_alGetListener3i;
	alias void function(ALenum, ALint*) da_alGetListeneriv;
	alias void function(ALsizei, ALuint*) da_alGenSources;
	alias void function(ALsizei, const(ALuint)*) da_alDeleteSources;
	alias ALboolean function(ALuint) da_alIsSource;
	alias void function(ALuint, ALenum, ALfloat) da_alSourcef;
	alias void function(ALuint, ALenum, ALfloat, ALfloat, ALfloat) da_alSource3f;
	alias void function(ALuint, ALenum, const(ALfloat)*) da_alSourcefv;
	alias void function(ALuint, ALenum, ALint) da_alSourcei;
	alias void function(ALuint, ALenum, ALint, ALint, ALint) da_alSource3i;
	alias void function(ALuint, ALenum, const(ALint)*) da_alSourceiv;
	alias void function(ALuint, ALenum, ALfloat*) da_alGetSourcef;
	alias void function(ALuint, ALenum, ALfloat*, ALfloat*, ALfloat*) da_alGetSource3f;
	alias void function(ALuint, ALenum, ALfloat*) da_alGetSourcefv;
	alias void function(ALuint, ALenum, ALint*) da_alGetSourcei;
	alias void function(ALuint, ALenum, ALint*, ALint*, ALint*) da_alGetSource3i;
	alias void function(ALuint, ALenum, ALint*) da_alGetSourceiv;
	alias void function(ALsizei, const(ALuint)*) da_alSourcePlayv;
	alias void function(ALsizei, const(ALuint)*) da_alSourceStopv;
	alias void function(ALsizei, const(ALuint)*) da_alSourceRewindv;
	alias void function(ALsizei, const(ALuint)*) da_alSourcePausev;
	alias void function(ALuint) da_alSourcePlay;
	alias void function(ALuint) da_alSourcePause;
	alias void function(ALuint) da_alSourceRewind;
	alias void function(ALuint) da_alSourceStop;
	alias void function(ALuint, ALsizei, ALuint*) da_alSourceQueueBuffers;
	alias void function(ALuint, ALsizei, ALuint*) da_alSourceUnqueueBuffers;
	alias void function(ALsizei, ALuint*) da_alGenBuffers;
	alias void function(ALsizei, const(ALuint)*) da_alDeleteBuffers;
	alias ALboolean function(ALuint) da_alIsBuffer;
	alias void function(ALuint, ALenum, const(ALvoid)*, ALsizei, ALsizei) da_alBufferData;
	alias void function(ALuint, ALenum, ALfloat) da_alBufferf;
	alias void function(ALuint, ALenum, ALfloat, ALfloat, ALfloat) da_alBuffer3f;
	alias void function(ALuint, ALenum, const(ALfloat)*) da_alBufferfv;
	alias void function(ALuint, ALenum, ALint) da_alBufferi;
	alias void function(ALuint, ALenum, ALint, ALint, ALint) da_alBuffer3i;
	alias void function(ALuint, ALenum, const(ALint)*) da_alBufferiv;
	alias void function(ALuint, ALenum, ALfloat*) da_alGetBufferf;
	alias void function(ALuint, ALenum, ALfloat*, ALfloat*, ALfloat*) da_alGetBuffer3f;
	alias void function(ALuint, ALenum, ALfloat*) da_alGetBufferfv;
	alias void function(ALuint, ALenum, ALint*) da_alGetBufferi;
	alias void function(ALuint, ALenum, ALint*, ALint*, ALint*) da_alGetBuffer3i;
	alias void function(ALuint, ALenum, ALint*) da_alGetBufferiv;
	alias void function(ALfloat) da_alDopplerFactor;
	alias void function(ALfloat) da_alDopplerVelocity;
	alias void function(ALfloat) da_alSpeedOfSound;
	alias void function(ALenum) da_alDistanceModel;
	alias ALCcontext* function(ALCdevice*, const(ALCint)*) da_alcCreateContext;
	alias ALCboolean function(ALCcontext*) da_alcMakeContextCurrent;
	alias void function(ALCcontext*) da_alcProcessContext;
	alias void function(ALCcontext*) da_alcSuspendContext;
	alias void function(ALCcontext*) da_alcDestroyContext;
	alias ALCcontext* function() da_alcGetCurrentContext;
	alias ALCdevice* function(ALCcontext*) da_alcGetContextsDevice;
	alias ALCdevice* function(const(char)*) da_alcOpenDevice;
	alias ALCboolean function(ALCdevice*) da_alcCloseDevice;
	alias ALCenum function(ALCdevice*) da_alcGetError;
	alias ALCboolean function(ALCdevice*, const(char)*) da_alcIsExtensionPresent;
	alias void* function(ALCdevice*, const(char)*) da_alcGetProcAddress;
	alias ALCenum function(ALCdevice*, const(char)*) da_alcGetEnumValue;
	alias const(char)* function(ALCdevice*, ALCenum) da_alcGetString;
	alias void function(ALCdevice*, ALCenum, ALCsizei, ALCint*) da_alcGetIntegerv;
	alias ALCdevice* function(const(char)*, ALCuint, ALCenum, ALCsizei) da_alcCaptureOpenDevice;
	alias ALCboolean function(ALCdevice*) da_alcCaptureCloseDevice;
	alias void function(ALCdevice*) da_alcCaptureStart;
	alias void function(ALCdevice*) da_alcCaptureStop;
	alias void function(ALCdevice*, ALCvoid*, ALCsizei) da_alcCaptureSamples;
}

__gshared 
{
	da_alEnable alEnable;
	da_alDisable alDisable;
	da_alIsEnabled alIsEnabled;
	da_alGetString alGetString;
	da_alGetBooleanv alGetBooleanv;
	da_alGetIntegerv alGetIntegerv;
	da_alGetFloatv alGetFloatv;
	da_alGetDoublev alGetDoublev;
	da_alGetBoolean alGetBoolean;
	da_alGetInteger alGetInteger;
	da_alGetFloat alGetFloat;
	da_alGetDouble alGetDouble;
	da_alGetError alGetError;
	da_alIsExtensionPresent alIsExtensionPresent;
	da_alGetProcAddress alGetProcAddress;
	da_alGetEnumValue alGetEnumValue;
	da_alListenerf alListenerf;
	da_alListener3f alListener3f;
	da_alListenerfv alListenerfv;
	da_alListeneri alListeneri;
	da_alListener3i alListener3i;
	da_alListeneriv alListeneriv;
	da_alGetListenerf alGetListenerf;
	da_alGetListener3f alGetListener3f;
	da_alGetListenerfv alGetListenerfv;
	da_alGetListeneri alGetListeneri;
	da_alGetListener3i alGetListener3i;
	da_alGetListeneriv alGetListeneriv;
	da_alGenSources alGenSources;
	da_alDeleteSources alDeleteSources;
	da_alIsSource alIsSource;
	da_alSourcef alSourcef;
	da_alSource3f alSource3f;
	da_alSourcefv alSourcefv;
	da_alSourcei alSourcei;
	da_alSource3i alSource3i;
	da_alSourceiv alSourceiv;
	da_alGetSourcef alGetSourcef;
	da_alGetSource3f alGetSource3f;
	da_alGetSourcefv alGetSourcefv;
	da_alGetSourcei alGetSourcei;
	da_alGetSource3i alGetSource3i;
	da_alGetSourceiv alGetSourceiv;
	da_alSourcePlayv alSourcePlayv;
	da_alSourceStopv alSourceStopv;
	da_alSourceRewindv alSourceRewindv;
	da_alSourcePausev alSourcePausev;
	da_alSourcePlay alSourcePlay;
	da_alSourcePause alSourcePause;
	da_alSourceRewind alSourceRewind;
	da_alSourceStop alSourceStop;
	da_alSourceQueueBuffers alSourceQueueBuffers;
	da_alSourceUnqueueBuffers alSourceUnqueueBuffers;
	da_alGenBuffers alGenBuffers;
	da_alDeleteBuffers alDeleteBuffers;
	da_alIsBuffer alIsBuffer;
	da_alBufferData alBufferData;
	da_alBufferf alBufferf;
	da_alBuffer3f alBuffer3f;
	da_alBufferfv alBufferfv;
	da_alBufferi alBufferi;
	da_alBuffer3i alBuffer3i;
	da_alBufferiv alBufferiv;
	da_alGetBufferf alGetBufferf;
	da_alGetBuffer3f alGetBuffer3f;
	da_alGetBufferfv alGetBufferfv;
	da_alGetBufferi alGetBufferi;
	da_alGetBuffer3i alGetBuffer3i;
	da_alGetBufferiv alGetBufferiv;
	da_alDopplerFactor alDopplerFactor;
	da_alDopplerVelocity alDopplerVelocity;
	da_alSpeedOfSound alSpeedOfSound;
	da_alDistanceModel alDistanceModel;
	da_alcCreateContext alcCreateContext;
	da_alcMakeContextCurrent alcMakeContextCurrent;
	da_alcProcessContext alcProcessContext;
	da_alcSuspendContext alcSuspendContext;
	da_alcDestroyContext alcDestroyContext;
	da_alcGetCurrentContext alcGetCurrentContext;
	da_alcGetContextsDevice alcGetContextsDevice;
	da_alcOpenDevice alcOpenDevice;
	da_alcCloseDevice alcCloseDevice;
	da_alcGetError alcGetError;
	da_alcIsExtensionPresent alcIsExtensionPresent;
	da_alcGetProcAddress alcGetProcAddress;
	da_alcGetEnumValue alcGetEnumValue;
	da_alcGetString alcGetString;
	da_alcGetIntegerv alcGetIntegerv;
	da_alcCaptureOpenDevice alcCaptureOpenDevice;
	da_alcCaptureCloseDevice alcCaptureCloseDevice;
	da_alcCaptureStart alcCaptureStart;
	da_alcCaptureStop alcCaptureStop;
	da_alcCaptureSamples alcCaptureSamples;
}
class DerelictALLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();


}
__gshared DerelictALLoader DerelictAL;

shared static this();
