// D import file generated from 'derelict/sfml2/graphics.d'
module derelict.sfml2.graphics;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sfml2.system;
	import derelict.sfml2.window;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-graphics-2.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-graphics.2.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-graphics.so.2";
			}
			else
			{
				static assert(0, "Need to implement SFML2 Graphics libNames for this operating system.");
			}
		}
	}
}
struct sfCircleShape;
struct sfConvexShape;
struct sfFont;
struct sfImage;
struct sfShader;
struct sfRectangleShape;
struct sfRenderTexture;
struct sfRenderWindow;
struct sfShape;
struct sfSprite;
struct sfText;
struct sfTexture;
struct sfTransformable;
struct sfVertexArray;
struct sfView;
alias int sfBlendMode;
enum 
{
	sfBlendAlpha,
	sfBlendAdd,
	sfBlendMultiply,
	sfBlendNone,
}
struct sfColor
{
	sfUint8 r;
	sfUint8 g;
	sfUint8 b;
	sfUint8 a;
}
immutable(sfColor) sfBlack = sfColor(0, 0, 0, 255);
immutable(sfColor) sfWhite = sfColor(255, 255, 255, 255);
immutable(sfColor) sfRed = sfColor(255, 0, 0, 255);
immutable(sfColor) sfGreen = sfColor(0, 255, 0, 255);
immutable(sfColor) sfBlue = sfColor(0, 0, 255, 255);
immutable(sfColor) sfYellow = sfColor(255, 255, 0, 255);
immutable(sfColor) sfMagenta = sfColor(255, 0, 255, 255);
immutable(sfColor) sfCyan = sfColor(0, 255, 255, 255);
immutable(sfColor) sfTransparent = sfColor(0, 0, 0, 0);
struct sfGlyph
{
	int advance;
	sfIntRect bounds;
	sfIntRect textureRect;
}
alias int sfPrimitiveType;
enum 
{
	sfPoints,
	sfLines,
	sfLinesStrip,
	sfTriangles,
	sfTrianglesStrip,
	sfTrianglesFan,
	sfQuads,
}
struct sfFloatRect
{
	float left;
	float top;
	float width;
	float height;
}
struct sfIntRect
{
	int left;
	int top;
	int width;
	int height;
}
struct sfRenderStates
{
	sfBlendMode blendMode;
	sfTransform transform;
	const(sfTexture)* texture;
	const(sfShader)* shader;
}
extern (C) nothrow 
{
	alias uint function(void*) sfShapeGetPointCountCallback;
	alias sfVector2f function(uint, void*) sfShapeGetPointCallback;
}

alias int sfTextStyle;
enum 
{
	sfTextRegular = 0,
	sfTextBold = 1 << 0,
	sfTextItalic = 1 << 1,
	sfTextUnderlined = 1 << 2,
}
struct sfTransform
{
	float[9] matrix;
}
const sfTransform sfTransform_Identity = sfTransform([1.00000F, 0.00000F, 0.00000F, 0.00000F, 1.00000F, 0.00000F, 0.00000F, 0.00000F, 1.00000F]);

struct sfVertex
{
	sfVector2f position;
	sfColor color;
	sfVector2f texCoords;
}
extern (C) nothrow 
{
	alias sfCircleShape* function() da_sfCircleShape_create;
	alias sfCircleShape* function(const(sfCircleShape)* shape) da_sfCircleShape_copy;
	alias void function(sfCircleShape* shape) da_sfCircleShape_destroy;
	alias void function(sfCircleShape* shape, sfVector2f position) da_sfCircleShape_setPosition;
	alias void function(sfCircleShape* shape, float angle) da_sfCircleShape_setRotation;
	alias void function(sfCircleShape* shape, sfVector2f scale) da_sfCircleShape_setScale;
	alias void function(sfCircleShape* shape, sfVector2f origin) da_sfCircleShape_setOrigin;
	alias sfVector2f function(const(sfCircleShape)* shape) da_sfCircleShape_getPosition;
	alias float function(const(sfCircleShape)* shape) da_sfCircleShape_getRotation;
	alias sfVector2f function(const(sfCircleShape)* shape) da_sfCircleShape_getScale;
	alias sfVector2f function(const(sfCircleShape)* shape) da_sfCircleShape_getOrigin;
	alias void function(sfCircleShape* shape, sfVector2f offset) da_sfCircleShape_move;
	alias void function(sfCircleShape* shape, float angle) da_sfCircleShape_rotate;
	alias void function(sfCircleShape* shape, sfVector2f factors) da_sfCircleShape_scale;
	alias sfTransform function(const(sfCircleShape)* shape) da_sfCircleShape_getTransform;
	alias sfTransform function(const(sfCircleShape)* shape) da_sfCircleShape_getInverseTransform;
	alias void function(sfCircleShape* shape, const(sfTexture)* texture, sfBool resetRect) da_sfCircleShape_setTexture;
	alias void function(sfCircleShape* shape, sfIntRect rect) da_sfCircleShape_setTextureRect;
	alias void function(sfCircleShape* shape, sfColor color) da_sfCircleShape_setFillColor;
	alias void function(sfCircleShape* shape, sfColor color) da_sfCircleShape_setOutlineColor;
	alias void function(sfCircleShape* shape, float thickness) da_sfCircleShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfCircleShape)* shape) da_sfCircleShape_getTexture;
	alias sfIntRect function(const(sfCircleShape)* shape) da_sfCircleShape_getTextureRect;
	alias sfColor function(const(sfCircleShape)* shape) da_sfCircleShape_getFillColor;
	alias sfColor function(const(sfCircleShape)* shape) da_sfCircleShape_getOutlineColor;
	alias float function(const(sfCircleShape)* shape) da_sfCircleShape_getOutlineThickness;
	alias uint function(const(sfCircleShape)* shape) da_sfCircleShape_getPointCount;
	alias sfVector2f function(const(sfCircleShape)* shape, uint index) da_sfCircleShape_getPoint;
	alias void function(sfCircleShape* shape, float radius) da_sfCircleShape_setRadius;
	alias float function(const(sfCircleShape)* shape) da_sfCircleShape_getRadius;
	alias void function(sfCircleShape* shape, uint count) da_sfCircleShape_setPointCount;
	alias sfFloatRect function(const(sfCircleShape)* shape) da_sfCircleShape_getLocalBounds;
	alias sfFloatRect function(const(sfCircleShape)* shape) da_sfCircleShape_getGlobalBounds;
	alias sfColor function(sfUint8 red, sfUint8 green, sfUint8 blue) da_sfColor_fromRGB;
	alias sfColor function(sfUint8 red, sfUint8 green, sfUint8 blue, sfUint8 alpha) da_sfColor_fromRGBA;
	alias sfColor function(sfColor color1, sfColor color2) da_sfColor_add;
	alias sfColor function(sfColor color1, sfColor color2) da_sfColor_modulate;
	alias sfConvexShape* function() da_sfConvexShape_create;
	alias sfConvexShape* function(const(sfConvexShape)* shape) da_sfConvexShape_copy;
	alias void function(sfConvexShape* shape) da_sfConvexShape_destroy;
	alias void function(sfConvexShape* shape, sfVector2f position) da_sfConvexShape_setPosition;
	alias void function(sfConvexShape* shape, float angle) da_sfConvexShape_setRotation;
	alias void function(sfConvexShape* shape, sfVector2f scale) da_sfConvexShape_setScale;
	alias void function(sfConvexShape* shape, sfVector2f origin) da_sfConvexShape_setOrigin;
	alias sfVector2f function(const(sfConvexShape)* shape) da_sfConvexShape_getPosition;
	alias float function(const(sfConvexShape)* shape) da_sfConvexShape_getRotation;
	alias sfVector2f function(const(sfConvexShape)* shape) da_sfConvexShape_getScale;
	alias sfVector2f function(const(sfConvexShape)* shape) da_sfConvexShape_getOrigin;
	alias void function(sfConvexShape* shape, sfVector2f offset) da_sfConvexShape_move;
	alias void function(sfConvexShape* shape, float angle) da_sfConvexShape_rotate;
	alias void function(sfConvexShape* shape, sfVector2f factors) da_sfConvexShape_scale;
	alias sfTransform function(const(sfConvexShape)* shape) da_sfConvexShape_getTransform;
	alias sfTransform function(const(sfConvexShape)* shape) da_sfConvexShape_getInverseTransform;
	alias void function(sfConvexShape* shape, const(sfTexture)* texture, sfBool resetRect) da_sfConvexShape_setTexture;
	alias void function(sfConvexShape* shape, sfIntRect rect) da_sfConvexShape_setTextureRect;
	alias void function(sfConvexShape* shape, sfColor color) da_sfConvexShape_setFillColor;
	alias void function(sfConvexShape* shape, sfColor color) da_sfConvexShape_setOutlineColor;
	alias void function(sfConvexShape* shape, float thickness) da_sfConvexShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfConvexShape)* shape) da_sfConvexShape_getTexture;
	alias sfIntRect function(const(sfConvexShape)* shape) da_sfConvexShape_getTextureRect;
	alias sfColor function(const(sfConvexShape)* shape) da_sfConvexShape_getFillColor;
	alias sfColor function(const(sfConvexShape)* shape) da_sfConvexShape_getOutlineColor;
	alias float function(const(sfConvexShape)* shape) da_sfConvexShape_getOutlineThickness;
	alias uint function(const(sfConvexShape)* shape) da_sfConvexShape_getPointCount;
	alias sfVector2f function(const(sfConvexShape)* shape, uint index) da_sfConvexShape_getPoint;
	alias void function(sfConvexShape* shape, uint count) da_sfConvexShape_setPointCount;
	alias void function(sfConvexShape* shape, uint index, sfVector2f point) da_sfConvexShape_setPoint;
	alias sfFloatRect function(const(sfConvexShape)* shape) da_sfConvexShape_getLocalBounds;
	alias sfFloatRect function(const(sfConvexShape)* shape) da_sfConvexShape_getGlobalBounds;
	alias sfFont* function(const(char)* filename) da_sfFont_createFromFile;
	alias sfFont* function(const(void)* data, size_t sizeInBytes) da_sfFont_createFromMemory;
	alias sfFont* function(sfInputStream* stream) da_sfFont_createFromStream;
	alias sfFont* function(const(sfFont)* font) da_sfFont_copy;
	alias void function(sfFont* font) da_sfFont_destroy;
	alias sfGlyph function(sfFont* font, sfUint32 codePoint, uint characterSize, sfBool bold) da_sfFont_getGlyph;
	alias int function(sfFont* font, sfUint32 first, sfUint32 second, uint characterSize) da_sfFont_getKerning;
	alias int function(sfFont* font, uint characterSize) da_sfFont_getLineSpacing;
	alias const(sfTexture)* function(sfFont* font, uint characterSize) da_sfFont_getTexture;
	alias sfImage* function(uint width, uint height) da_sfImage_create;
	alias sfImage* function(uint width, uint height, sfColor color) da_sfImage_createFromColor;
	alias sfImage* function(uint width, uint height, const(sfUint8)* pixels) da_sfImage_createFromPixels;
	alias sfImage* function(const(char)* filename) da_sfImage_createFromFile;
	alias sfImage* function(const(void)* data, size_t size) da_sfImage_createFromMemory;
	alias sfImage* function(sfInputStream* stream) da_sfImage_createFromStream;
	alias sfImage* function(const(sfImage)* image) da_sfImage_copy;
	alias void function(sfImage* image) da_sfImage_destroy;
	alias sfBool function(const(sfImage)* image, const(char)* filename) da_sfImage_saveToFile;
	alias sfVector2u function(const(sfImage)* image) da_sfImage_getSize;
	alias void function(sfImage* image, sfColor color, sfUint8 alpha) da_sfImage_createMaskFromColor;
	alias void function(sfImage* image, const(sfImage)* source, uint destX, uint destY, sfIntRect sourceRect, sfBool applyAlpha) da_sfImage_copyImage;
	alias void function(sfImage* image, uint x, uint y, sfColor color) da_sfImage_setPixel;
	alias sfColor function(const(sfImage)* image, uint x, uint y) da_sfImage_getPixel;
	alias const(sfUint8)* function(const(sfImage)* image) da_sfImage_getPixelsPtr;
	alias void function(sfImage* image) da_sfImage_flipHorizontally;
	alias void function(sfImage* image) da_sfImage_flipVertically;
	alias sfBool function(const(sfFloatRect)* rect, float x, float y) da_sfFloatRect_contains;
	alias sfBool function(const(sfIntRect)* rect, int x, int y) da_sfIntRect_contains;
	alias sfBool function(const(sfFloatRect)* rect1, const(sfFloatRect)* rect2, sfFloatRect* intersection) da_sfFloatRect_intersects;
	alias sfBool function(const(sfIntRect)* rect1, const(sfIntRect)* rect2, sfIntRect* intersection) da_sfIntRect_intersects;
	alias sfRectangleShape* function() da_sfRectangleShape_create;
	alias sfRectangleShape* function(const(sfRectangleShape)* shape) da_sfRectangleShape_copy;
	alias void function(sfRectangleShape* shape) da_sfRectangleShape_destroy;
	alias void function(sfRectangleShape* shape, sfVector2f position) da_sfRectangleShape_setPosition;
	alias void function(sfRectangleShape* shape, float angle) da_sfRectangleShape_setRotation;
	alias void function(sfRectangleShape* shape, sfVector2f scale) da_sfRectangleShape_setScale;
	alias void function(sfRectangleShape* shape, sfVector2f origin) da_sfRectangleShape_setOrigin;
	alias sfVector2f function(const(sfRectangleShape)* shape) da_sfRectangleShape_getPosition;
	alias float function(const(sfRectangleShape)* shape) da_sfRectangleShape_getRotation;
	alias sfVector2f function(const(sfRectangleShape)* shape) da_sfRectangleShape_getScale;
	alias sfVector2f function(const(sfRectangleShape)* shape) da_sfRectangleShape_getOrigin;
	alias void function(sfRectangleShape* shape, sfVector2f offset) da_sfRectangleShape_move;
	alias void function(sfRectangleShape* shape, float angle) da_sfRectangleShape_rotate;
	alias void function(sfRectangleShape* shape, sfVector2f factors) da_sfRectangleShape_scale;
	alias sfTransform function(const(sfRectangleShape)* shape) da_sfRectangleShape_getTransform;
	alias sfTransform function(const(sfRectangleShape)* shape) da_sfRectangleShape_getInverseTransform;
	alias void function(sfRectangleShape* shape, const(sfTexture)* texture, sfBool resetRect) da_sfRectangleShape_setTexture;
	alias void function(sfRectangleShape* shape, sfIntRect rect) da_sfRectangleShape_setTextureRect;
	alias void function(sfRectangleShape* shape, sfColor color) da_sfRectangleShape_setFillColor;
	alias void function(sfRectangleShape* shape, sfColor color) da_sfRectangleShape_setOutlineColor;
	alias void function(sfRectangleShape* shape, float thickness) da_sfRectangleShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfRectangleShape)* shape) da_sfRectangleShape_getTexture;
	alias sfIntRect function(const(sfRectangleShape)* shape) da_sfRectangleShape_getTextureRect;
	alias sfColor function(const(sfRectangleShape)* shape) da_sfRectangleShape_getFillColor;
	alias sfColor function(const(sfRectangleShape)* shape) da_sfRectangleShape_getOutlineColor;
	alias float function(const(sfRectangleShape)* shape) da_sfRectangleShape_getOutlineThickness;
	alias uint function(const(sfRectangleShape)* shape) da_sfRectangleShape_getPointCount;
	alias sfVector2f function(const(sfRectangleShape)* shape, uint index) da_sfRectangleShape_getPoint;
	alias void function(sfRectangleShape* shape, sfVector2f size) da_sfRectangleShape_setSize;
	alias sfVector2f function(const(sfRectangleShape)* shape) da_sfRectangleShape_getSize;
	alias sfFloatRect function(const(sfRectangleShape)* shape) da_sfRectangleShape_getLocalBounds;
	alias sfFloatRect function(const(sfRectangleShape)* shape) da_sfRectangleShape_getGlobalBounds;
	alias sfRenderTexture* function(uint width, uint height, sfBool depthBuffer) da_sfRenderTexture_create;
	alias void function(sfRenderTexture* renderTexture) da_sfRenderTexture_destroy;
	alias sfVector2u function(const(sfRenderTexture)* renderTexture) da_sfRenderTexture_getSize;
	alias sfBool function(sfRenderTexture* renderTexture, sfBool active) da_sfRenderTexture_setActive;
	alias void function(sfRenderTexture* renderTexture) da_sfRenderTexture_display;
	alias void function(sfRenderTexture* renderTexture, sfColor color) da_sfRenderTexture_clear;
	alias void function(sfRenderTexture* renderTexture, const(sfView)* view) da_sfRenderTexture_setView;
	alias const(sfView)* function(const(sfRenderTexture)* renderTexture) da_sfRenderTexture_getView;
	alias const(sfView)* function(const(sfRenderTexture)* renderTexture) da_sfRenderTexture_getDefaultView;
	alias sfIntRect function(const(sfRenderTexture)* renderTexture, const(sfView)* view) da_sfRenderTexture_getViewport;
	alias sfVector2f function(const(sfRenderTexture)* renderTexture, sfVector2i point, const(sfView)* view) da_sfRenderTexture_mapPixelToCoords;
	alias sfVector2i function(const(sfRenderTexture)* renderTexture, sfVector2f point, const(sfView)* view) da_sfRenderTexture_mapCoordsToPixel;
	alias void function(sfRenderTexture* renderTexture, const(sfSprite)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawSprite;
	alias void function(sfRenderTexture* renderTexture, const(sfText)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawText;
	alias void function(sfRenderTexture* renderTexture, const(sfShape)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawShape;
	alias void function(sfRenderTexture* renderTexture, const(sfCircleShape)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawCircleShape;
	alias void function(sfRenderTexture* renderTexture, const(sfConvexShape)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawConvexShape;
	alias void function(sfRenderTexture* renderTexture, const(sfRectangleShape)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawRectangleShape;
	alias void function(sfRenderTexture* renderTexture, const(sfVertexArray)* object, const(sfRenderStates)* states) da_sfRenderTexture_drawVertexArray;
	alias void function(sfRenderTexture* renderTexture, const(sfVertex)* vertices, uint vertexCount, sfPrimitiveType type, const(sfRenderStates)* states) da_sfRenderTexture_drawPrimitives;
	alias void function(sfRenderTexture* renderTexture) da_sfRenderTexture_pushGLStates;
	alias void function(sfRenderTexture* renderTexture) da_sfRenderTexture_popGLStates;
	alias void function(sfRenderTexture* renderTexture) da_sfRenderTexture_resetGLStates;
	alias const(sfTexture)* function(const(sfRenderTexture)* renderTexture) da_sfRenderTexture_getTexture;
	alias void function(sfRenderTexture* renderTexture, sfBool smooth) da_sfRenderTexture_setSmooth;
	alias sfBool function(const(sfRenderTexture)* renderTexture) da_sfRenderTexture_isSmooth;
	alias sfRenderWindow* function(sfVideoMode mode, const(char)* title, sfUint32 style, const(sfContextSettings)* settings) da_sfRenderWindow_create;
	alias sfRenderWindow* function(sfWindowHandle handle, const(sfContextSettings)* settings) da_sfRenderWindow_createFromHandle;
	alias void function(sfRenderWindow* renderWindow) da_sfRenderWindow_destroy;
	alias void function(sfRenderWindow* renderWindow) da_sfRenderWindow_close;
	alias sfBool function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_isOpen;
	alias sfContextSettings function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_getSettings;
	alias sfBool function(sfRenderWindow* renderWindow, sfEvent* event) da_sfRenderWindow_pollEvent;
	alias sfBool function(sfRenderWindow* renderWindow, sfEvent* event) da_sfRenderWindow_waitEvent;
	alias sfVector2i function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_getPosition;
	alias void function(sfRenderWindow* renderWindow, sfVector2i position) da_sfRenderWindow_setPosition;
	alias sfVector2u function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_getSize;
	alias void function(sfRenderWindow* renderWindow, sfVector2u size) da_sfRenderWindow_setSize;
	alias void function(sfRenderWindow* renderWindow, const(char)* title) da_sfRenderWindow_setTitle;
	alias void function(sfRenderWindow* renderWindow, uint width, uint height, const(sfUint8)* pixels) da_sfRenderWindow_setIcon;
	alias void function(sfRenderWindow* renderWindow, sfBool visible) da_sfRenderWindow_setVisible;
	alias void function(sfRenderWindow* renderWindow, sfBool show) da_sfRenderWindow_setMouseCursorVisible;
	alias void function(sfRenderWindow* renderWindow, sfBool enabled) da_sfRenderWindow_setVerticalSyncEnabled;
	alias void function(sfRenderWindow* renderWindow, sfBool enabled) da_sfRenderWindow_setKeyRepeatEnabled;
	alias sfBool function(sfRenderWindow* renderWindow, sfBool active) da_sfRenderWindow_setActive;
	alias void function(sfRenderWindow* renderWindow) da_sfRenderWindow_display;
	alias void function(sfRenderWindow* renderWindow, uint limit) da_sfRenderWindow_setFramerateLimit;
	alias void function(sfRenderWindow* renderWindow, float threshold) da_sfRenderWindow_setJoystickThreshold;
	alias sfWindowHandle function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_getSystemHandle;
	alias void function(sfRenderWindow* renderWindow, sfColor color) da_sfRenderWindow_clear;
	alias void function(sfRenderWindow* renderWindow, const(sfView)* view) da_sfRenderWindow_setView;
	alias const(sfView)* function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_getView;
	alias const(sfView)* function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_getDefaultView;
	alias sfIntRect function(const(sfRenderWindow)* renderWindow, const(sfView)* view) da_sfRenderWindow_getViewport;
	alias sfVector2f function(const(sfRenderWindow)* renderWindow, sfVector2i point, const(sfView)* view) da_sfRenderWindow_mapPixelToCoords;
	alias sfVector2i function(const(sfRenderWindow)* renderWindow, sfVector2f point, const(sfView)* view) da_sfRenderWindow_mapCoordsToPixel;
	alias void function(sfRenderWindow* renderWindow, const(sfSprite)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawSprite;
	alias void function(sfRenderWindow* renderWindow, const(sfText)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawText;
	alias void function(sfRenderWindow* renderWindow, const(sfShape)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawShape;
	alias void function(sfRenderWindow* renderWindow, const(sfCircleShape)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawCircleShape;
	alias void function(sfRenderWindow* renderWindow, const(sfConvexShape)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawConvexShape;
	alias void function(sfRenderWindow* renderWindow, const(sfRectangleShape)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawRectangleShape;
	alias void function(sfRenderWindow* renderWindow, const(sfVertexArray)* object, const(sfRenderStates)* states) da_sfRenderWindow_drawVertexArray;
	alias void function(sfRenderWindow* renderWindow, sfVertex* vertices, uint vertexCount, sfPrimitiveType type, const(sfRenderStates)* states) da_sfRenderWindow_drawPrimitives;
	alias void function(sfRenderWindow* renderWindow) da_sfRenderWindow_pushGLStates;
	alias void function(sfRenderWindow* renderWindow) da_sfRenderWindow_popGLStates;
	alias void function(sfRenderWindow* renderWindow) da_sfRenderWindow_resetGLStates;
	alias sfImage* function(const(sfRenderWindow)* renderWindow) da_sfRenderWindow_capture;
	alias sfVector2i function(const(sfRenderWindow)* relativeTo) da_sfMouse_getPositionRenderWindow;
	alias void function(sfVector2i position, const(sfRenderWindow)* relativeTo) da_sfMouse_setPositionRenderWindow;
	alias sfShader* function(const(char)* vertexShaderFilename, const(char)* fragmentShaderFilename) da_sfShader_createFromFile;
	alias sfShader* function(const(char)* vertexShader, const(char)* fragmentShader) da_sfShader_createFromMemory;
	alias sfShader* function(sfInputStream* vertexShaderStream, sfInputStream* fragmentShaderStream) da_sfShader_createFromStream;
	alias void function(sfShader* shader) da_sfShader_destroy;
	alias void function(sfShader* shader, const(char)* name, float x) da_sfShader_setFloatParameter;
	alias void function(sfShader* shader, const(char)* name, float x, float y) da_sfShader_setFloat2Parameter;
	alias void function(sfShader* shader, const(char)* name, float x, float y, float z) da_sfShader_setFloat3Parameter;
	alias void function(sfShader* shader, const(char)* name, float x, float y, float z, float w) da_sfShader_setFloat4Parameter;
	alias void function(sfShader* shader, const(char)* name, sfVector2f vector) da_sfShader_setVector2Parameter;
	alias void function(sfShader* shader, const(char)* name, sfVector3f vector) da_sfShader_setVector3Parameter;
	alias void function(sfShader* shader, const(char)* name, sfColor color) da_sfShader_setColorParameter;
	alias void function(sfShader* shader, const(char)* name, sfTransform transform) da_sfShader_setTransformParameter;
	alias void function(sfShader* shader, const(char)* name, const(sfTexture)* texture) da_sfShader_setTextureParameter;
	alias void function(sfShader* shader, const(char)* name) da_sfShader_setCurrentTextureParameter;
	alias void function(const(sfShader)* shader) da_sfShader_bind;
	alias sfBool function() da_sfShader_isAvailable;
	alias sfShape* function(sfShapeGetPointCountCallback getPointCount, sfShapeGetPointCallback getPoint) da_sfShape_create;
	alias void function(sfShape* shape) da_sfShape_destroy;
	alias void function(sfShape* shape, sfVector2f position) da_sfShape_setPosition;
	alias void function(sfShape* shape, float angle) da_sfShape_setRotation;
	alias void function(sfShape* shape, sfVector2f scale) da_sfShape_setScale;
	alias void function(sfShape* shape, sfVector2f origin) da_sfShape_setOrigin;
	alias sfVector2f function(const(sfShape)* shape) da_sfShape_getPosition;
	alias float function(const(sfShape)* shape) da_sfShape_getRotation;
	alias sfVector2f function(const(sfShape)* shape) da_sfShape_getScale;
	alias sfVector2f function(const(sfShape)* shape) da_sfShape_getOrigin;
	alias void function(sfShape* shape, sfVector2f offset) da_sfShape_move;
	alias void function(sfShape* shape, float angle) da_sfShape_rotate;
	alias void function(sfShape* shape, sfVector2f factors) da_sfShape_scale;
	alias sfTransform function(const(sfShape)* shape) da_sfShape_getTransform;
	alias sfTransform function(const(sfShape)* shape) da_sfShape_getInverseTransform;
	alias void function(sfShape* shape, const(sfTexture)* texture, sfBool resetRect) da_sfShape_setTexture;
	alias void function(sfShape* shape, sfIntRect rect) da_sfShape_setTextureRect;
	alias void function(sfShape* shape, sfColor color) da_sfShape_setFillColor;
	alias void function(sfShape* shape, sfColor color) da_sfShape_setOutlineColor;
	alias void function(sfShape* shape, float thickness) da_sfShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfShape)* shape) da_sfShape_getTexture;
	alias sfIntRect function(const(sfShape)* shape) da_sfShape_getTextureRect;
	alias sfColor function(const(sfShape)* shape) da_sfShape_getFillColor;
	alias sfColor function(const(sfShape)* shape) da_sfShape_getOutlineColor;
	alias float function(const(sfShape)* shape) da_sfShape_getOutlineThickness;
	alias uint function(const(sfShape)* shape) da_sfShape_getPointCount;
	alias sfVector2f function(const(sfShape)* shape, uint index) da_sfShape_getPoint;
	alias sfFloatRect function(const(sfShape)* shape) da_sfShape_getLocalBounds;
	alias sfFloatRect function(const(sfShape)* shape) da_sfShape_getGlobalBounds;
	alias void function(sfShape* shape) da_sfShape_update;
	alias sfSprite* function() da_sfSprite_create;
	alias sfSprite* function(const(sfSprite)* sprite) da_sfSprite_copy;
	alias void function(sfSprite* sprite) da_sfSprite_destroy;
	alias void function(sfSprite* sprite, sfVector2f position) da_sfSprite_setPosition;
	alias void function(sfSprite* sprite, float angle) da_sfSprite_setRotation;
	alias void function(sfSprite* sprite, sfVector2f scale) da_sfSprite_setScale;
	alias void function(sfSprite* sprite, sfVector2f origin) da_sfSprite_setOrigin;
	alias sfVector2f function(const(sfSprite)* sprite) da_sfSprite_getPosition;
	alias float function(const(sfSprite)* sprite) da_sfSprite_getRotation;
	alias sfVector2f function(const(sfSprite)* sprite) da_sfSprite_getScale;
	alias sfVector2f function(const(sfSprite)* sprite) da_sfSprite_getOrigin;
	alias void function(sfSprite* sprite, sfVector2f offset) da_sfSprite_move;
	alias void function(sfSprite* sprite, float angle) da_sfSprite_rotate;
	alias void function(sfSprite* sprite, sfVector2f factors) da_sfSprite_scale;
	alias sfTransform function(const(sfSprite)* sprite) da_sfSprite_getTransform;
	alias sfTransform function(const(sfSprite)* sprite) da_sfSprite_getInverseTransform;
	alias void function(sfSprite* sprite, const(sfTexture)* texture, sfBool resetRect) da_sfSprite_setTexture;
	alias void function(sfSprite* sprite, sfIntRect rectangle) da_sfSprite_setTextureRect;
	alias void function(sfSprite* sprite, sfColor color) da_sfSprite_setColor;
	alias const(sfTexture)* function(const(sfSprite)* sprite) da_sfSprite_getTexture;
	alias sfIntRect function(const(sfSprite)* sprite) da_sfSprite_getTextureRect;
	alias sfColor function(const(sfSprite)* sprite) da_sfSprite_getColor;
	alias sfFloatRect function(const(sfSprite)* sprite) da_sfSprite_getLocalBounds;
	alias sfFloatRect function(const(sfSprite)* sprite) da_sfSprite_getGlobalBounds;
	alias sfText* function() da_sfText_create;
	alias sfText* function(const(sfText)* text) da_sfText_copy;
	alias void function(sfText* text) da_sfText_destroy;
	alias void function(sfText* text, sfVector2f position) da_sfText_setPosition;
	alias void function(sfText* text, float angle) da_sfText_setRotation;
	alias void function(sfText* text, sfVector2f scale) da_sfText_setScale;
	alias void function(sfText* text, sfVector2f origin) da_sfText_setOrigin;
	alias sfVector2f function(const(sfText)* text) da_sfText_getPosition;
	alias float function(const(sfText)* text) da_sfText_getRotation;
	alias sfVector2f function(const(sfText)* text) da_sfText_getScale;
	alias sfVector2f function(const(sfText)* text) da_sfText_getOrigin;
	alias void function(sfText* text, sfVector2f offset) da_sfText_move;
	alias void function(sfText* text, float angle) da_sfText_rotate;
	alias void function(sfText* text, sfVector2f factors) da_sfText_scale;
	alias sfTransform function(const(sfText)* text) da_sfText_getTransform;
	alias sfTransform function(const(sfText)* text) da_sfText_getInverseTransform;
	alias void function(sfText* text, const(char)* string) da_sfText_setString;
	alias void function(sfText* text, const(sfUint32)* string) da_sfText_setUnicodeString;
	alias void function(sfText* text, const(sfFont)* font) da_sfText_setFont;
	alias void function(sfText* text, uint size) da_sfText_setCharacterSize;
	alias void function(sfText* text, sfUint32 style) da_sfText_setStyle;
	alias void function(sfText* text, sfColor color) da_sfText_setColor;
	alias const(char)* function(const(sfText)* text) da_sfText_getString;
	alias const(sfUint32)* function(const(sfText)* text) da_sfText_getUnicodeString;
	alias const(sfFont)* function(const(sfText)* text) da_sfText_getFont;
	alias uint function(const(sfText)* text) da_sfText_getCharacterSize;
	alias sfUint32 function(const(sfText)* text) da_sfText_getStyle;
	alias sfColor function(const(sfText)* text) da_sfText_getColor;
	alias sfVector2f function(const(sfText)* text, size_t index) da_sfText_findCharacterPos;
	alias sfFloatRect function(const(sfText)* text) da_sfText_getLocalBounds;
	alias sfFloatRect function(const(sfText)* text) da_sfText_getGlobalBounds;
	alias sfTexture* function(uint width, uint height) da_sfTexture_create;
	alias sfTexture* function(const(char)* filename, const(sfIntRect)* area) da_sfTexture_createFromFile;
	alias sfTexture* function(const(void)* data, size_t sizeInBytes, const(sfIntRect)* area) da_sfTexture_createFromMemory;
	alias sfTexture* function(sfInputStream* stream, const(sfIntRect)* area) da_sfTexture_createFromStream;
	alias sfTexture* function(const(sfImage)* image, const(sfIntRect)* area) da_sfTexture_createFromImage;
	alias sfTexture* function(const(sfTexture)* texture) da_sfTexture_copy;
	alias void function(sfTexture* texture) da_sfTexture_destroy;
	alias sfVector2u function(const(sfTexture)* texture) da_sfTexture_getSize;
	alias sfImage* function(const(sfTexture)* texture) da_sfTexture_copyToImage;
	alias void function(sfTexture* texture, const(sfUint8)* pixels, uint width, uint height, uint x, uint y) da_sfTexture_updateFromPixels;
	alias void function(sfTexture* texture, const(sfImage)* image, uint x, uint y) da_sfTexture_updateFromImage;
	alias void function(sfTexture* texture, const(sfWindow)* window, uint x, uint y) da_sfTexture_updateFromWindow;
	alias void function(sfTexture* texture, const(sfRenderWindow)* renderWindow, uint x, uint y) da_sfTexture_updateFromRenderWindow;
	alias void function(const(sfTexture)* texture) da_sfTexture_bind;
	alias void function(sfTexture* texture, sfBool smooth) da_sfTexture_setSmooth;
	alias sfBool function(const(sfTexture)* texture) da_sfTexture_isSmooth;
	alias void function(sfTexture* texture, sfBool repeated) da_sfTexture_setRepeated;
	alias sfBool function(const(sfTexture)* texture) da_sfTexture_isRepeated;
	alias uint function() da_sfTexture_getMaximumSize;
	alias sfTransform function(float a00, float a01, float a02, float a10, float a11, float a12, float a20, float a21, float a22) da_sfTransform_fromMatrix;
	alias void function(const(sfTransform)* transform, float* matrix) da_sfTransform_getMatrix;
	alias sfTransform function(const(sfTransform)* transform) da_sfTransform_getInverse;
	alias sfVector2f function(const(sfTransform)* transform, sfVector2f point) da_sfTransform_transformPoint;
	alias sfFloatRect function(const(sfTransform)* transform, sfFloatRect rectangle) da_sfTransform_transformRect;
	alias void function(sfTransform* transform, const(sfTransform)* other) da_sfTransform_combine;
	alias void function(sfTransform* transform, float x, float y) da_sfTransform_translate;
	alias void function(sfTransform* transform, float angle) da_sfTransform_rotate;
	alias void function(sfTransform* transform, float angle, float centerX, float centerY) da_sfTransform_rotateWithCenter;
	alias void function(sfTransform* transform, float scaleX, float scaleY) da_sfTransform_scale;
	alias void function(sfTransform* transform, float scaleX, float scaleY, float centerX, float centerY) da_sfTransform_scaleWithCenter;
	alias sfTransformable* function() da_sfTransformable_create;
	alias sfTransformable* function(const(sfTransformable)* transformable) da_sfTransformable_copy;
	alias void function(sfTransformable* transformable) da_sfTransformable_destroy;
	alias void function(sfTransformable* transformable, sfVector2f position) da_sfTransformable_setPosition;
	alias void function(sfTransformable* transformable, float angle) da_sfTransformable_setRotation;
	alias void function(sfTransformable* transformable, sfVector2f scale) da_sfTransformable_setScale;
	alias void function(sfTransformable* transformable, sfVector2f origin) da_sfTransformable_setOrigin;
	alias sfVector2f function(const(sfTransformable)* transformable) da_sfTransformable_getPosition;
	alias float function(const(sfTransformable)* transformable) da_sfTransformable_getRotation;
	alias sfVector2f function(const(sfTransformable)* transformable) da_sfTransformable_getScale;
	alias sfVector2f function(const(sfTransformable)* transformable) da_sfTransformable_getOrigin;
	alias void function(sfTransformable* transformable, sfVector2f offset) da_sfTransformable_move;
	alias void function(sfTransformable* transformable, float angle) da_sfTransformable_rotate;
	alias void function(sfTransformable* transformable, sfVector2f factors) da_sfTransformable_scale;
	alias sfTransform function(const(sfTransformable)* transformable) da_sfTransformable_getTransform;
	alias sfTransform function(const(sfTransformable)* transformable) da_sfTransformable_getInverseTransform;
	alias sfVertexArray* function() da_sfVertexArray_create;
	alias sfVertexArray* function(const(sfVertexArray)* vertexArray) da_sfVertexArray_copy;
	alias void function(sfVertexArray* vertexArray) da_sfVertexArray_destroy;
	alias uint function(const(sfVertexArray)* vertexArray) da_sfVertexArray_getVertexCount;
	alias sfVertex* function(sfVertexArray* vertexArray, uint index) da_sfVertexArray_getVertex;
	alias void function(sfVertexArray* vertexArray) da_sfVertexArray_clear;
	alias void function(sfVertexArray* vertexArray, uint vertexCount) da_sfVertexArray_resize;
	alias void function(sfVertexArray* vertexArray, sfVertex vertex) da_sfVertexArray_append;
	alias void function(sfVertexArray* vertexArray, sfPrimitiveType type) da_sfVertexArray_setPrimitiveType;
	alias sfPrimitiveType function(sfVertexArray* vertexArray) da_sfVertexArray_getPrimitiveType;
	alias sfFloatRect function(sfVertexArray* vertexArray) da_sfVertexArray_getBounds;
	alias sfView* function() da_sfView_create;
	alias sfView* function(sfFloatRect rectangle) da_sfView_createFromRect;
	alias sfView* function(const(sfView)* view) da_sfView_copy;
	alias void function(sfView* view) da_sfView_destroy;
	alias void function(sfView* view, sfVector2f center) da_sfView_setCenter;
	alias void function(sfView* view, sfVector2f size) da_sfView_setSize;
	alias void function(sfView* view, float angle) da_sfView_setRotation;
	alias void function(sfView* view, sfFloatRect viewport) da_sfView_setViewport;
	alias void function(sfView* view, sfFloatRect rectangle) da_sfView_reset;
	alias sfVector2f function(const(sfView)* view) da_sfView_getCenter;
	alias sfVector2f function(const(sfView)* view) da_sfView_getSize;
	alias float function(const(sfView)* view) da_sfView_getRotation;
	alias sfFloatRect function(const(sfView)* view) da_sfView_getViewport;
	alias void function(sfView* view, sfVector2f offset) da_sfView_move;
	alias void function(sfView* view, float angle) da_sfView_rotate;
	alias void function(sfView* view, float factor) da_sfView_zoom;
}

__gshared 
{
	da_sfCircleShape_create sfCircleShape_create;
	da_sfCircleShape_copy sfCircleShape_copy;
	da_sfCircleShape_destroy sfCircleShape_destroy;
	da_sfCircleShape_setPosition sfCircleShape_setPosition;
	da_sfCircleShape_setRotation sfCircleShape_setRotation;
	da_sfCircleShape_setScale sfCircleShape_setScale;
	da_sfCircleShape_setOrigin sfCircleShape_setOrigin;
	da_sfCircleShape_getPosition sfCircleShape_getPosition;
	da_sfCircleShape_getRotation sfCircleShape_getRotation;
	da_sfCircleShape_getScale sfCircleShape_getScale;
	da_sfCircleShape_getOrigin sfCircleShape_getOrigin;
	da_sfCircleShape_move sfCircleShape_move;
	da_sfCircleShape_rotate sfCircleShape_rotate;
	da_sfCircleShape_scale sfCircleShape_scale;
	da_sfCircleShape_getTransform sfCircleShape_getTransform;
	da_sfCircleShape_getInverseTransform sfCircleShape_getInverseTransform;
	da_sfCircleShape_setTexture sfCircleShape_setTexture;
	da_sfCircleShape_setTextureRect sfCircleShape_setTextureRect;
	da_sfCircleShape_setFillColor sfCircleShape_setFillColor;
	da_sfCircleShape_setOutlineColor sfCircleShape_setOutlineColor;
	da_sfCircleShape_setOutlineThickness sfCircleShape_setOutlineThickness;
	da_sfCircleShape_getTexture sfCircleShape_getTexture;
	da_sfCircleShape_getTextureRect sfCircleShape_getTextureRect;
	da_sfCircleShape_getFillColor sfCircleShape_getFillColor;
	da_sfCircleShape_getOutlineColor sfCircleShape_getOutlineColor;
	da_sfCircleShape_getOutlineThickness sfCircleShape_getOutlineThickness;
	da_sfCircleShape_getPointCount sfCircleShape_getPointCount;
	da_sfCircleShape_getPoint sfCircleShape_getPoint;
	da_sfCircleShape_setRadius sfCircleShape_setRadius;
	da_sfCircleShape_getRadius sfCircleShape_getRadius;
	da_sfCircleShape_setPointCount sfCircleShape_setPointCount;
	da_sfCircleShape_getLocalBounds sfCircleShape_getLocalBounds;
	da_sfCircleShape_getGlobalBounds sfCircleShape_getGlobalBounds;
	da_sfColor_fromRGB sfColor_fromRGB;
	da_sfColor_fromRGBA sfColor_fromRGBA;
	da_sfColor_add sfColor_add;
	da_sfColor_modulate sfColor_modulate;
	da_sfConvexShape_create sfConvexShape_create;
	da_sfConvexShape_copy sfConvexShape_copy;
	da_sfConvexShape_destroy sfConvexShape_destroy;
	da_sfConvexShape_setPosition sfConvexShape_setPosition;
	da_sfConvexShape_setRotation sfConvexShape_setRotation;
	da_sfConvexShape_setScale sfConvexShape_setScale;
	da_sfConvexShape_setOrigin sfConvexShape_setOrigin;
	da_sfConvexShape_getPosition sfConvexShape_getPosition;
	da_sfConvexShape_getRotation sfConvexShape_getRotation;
	da_sfConvexShape_getScale sfConvexShape_getScale;
	da_sfConvexShape_getOrigin sfConvexShape_getOrigin;
	da_sfConvexShape_move sfConvexShape_move;
	da_sfConvexShape_rotate sfConvexShape_rotate;
	da_sfConvexShape_scale sfConvexShape_scale;
	da_sfConvexShape_getTransform sfConvexShape_getTransform;
	da_sfConvexShape_getInverseTransform sfConvexShape_getInverseTransform;
	da_sfConvexShape_setTexture sfConvexShape_setTexture;
	da_sfConvexShape_setTextureRect sfConvexShape_setTextureRect;
	da_sfConvexShape_setFillColor sfConvexShape_setFillColor;
	da_sfConvexShape_setOutlineColor sfConvexShape_setOutlineColor;
	da_sfConvexShape_setOutlineThickness sfConvexShape_setOutlineThickness;
	da_sfConvexShape_getTexture sfConvexShape_getTexture;
	da_sfConvexShape_getTextureRect sfConvexShape_getTextureRect;
	da_sfConvexShape_getFillColor sfConvexShape_getFillColor;
	da_sfConvexShape_getOutlineColor sfConvexShape_getOutlineColor;
	da_sfConvexShape_getOutlineThickness sfConvexShape_getOutlineThickness;
	da_sfConvexShape_getPointCount sfConvexShape_getPointCount;
	da_sfConvexShape_getPoint sfConvexShape_getPoint;
	da_sfConvexShape_setPointCount sfConvexShape_setPointCount;
	da_sfConvexShape_setPoint sfConvexShape_setPoint;
	da_sfConvexShape_getLocalBounds sfConvexShape_getLocalBounds;
	da_sfConvexShape_getGlobalBounds sfConvexShape_getGlobalBounds;
	da_sfFont_createFromFile sfFont_createFromFile;
	da_sfFont_createFromMemory sfFont_createFromMemory;
	da_sfFont_createFromStream sfFont_createFromStream;
	da_sfFont_copy sfFont_copy;
	da_sfFont_destroy sfFont_destroy;
	da_sfFont_getGlyph sfFont_getGlyph;
	da_sfFont_getKerning sfFont_getKerning;
	da_sfFont_getLineSpacing sfFont_getLineSpacing;
	da_sfFont_getTexture sfFont_getTexture;
	da_sfImage_create sfImage_create;
	da_sfImage_createFromColor sfImage_createFromColor;
	da_sfImage_createFromPixels sfImage_createFromPixels;
	da_sfImage_createFromFile sfImage_createFromFile;
	da_sfImage_createFromMemory sfImage_createFromMemory;
	da_sfImage_createFromStream sfImage_createFromStream;
	da_sfImage_copy sfImage_copy;
	da_sfImage_destroy sfImage_destroy;
	da_sfImage_saveToFile sfImage_saveToFile;
	da_sfImage_getSize sfImage_getSize;
	da_sfImage_createMaskFromColor sfImage_createMaskFromColor;
	da_sfImage_copyImage sfImage_copyImage;
	da_sfImage_setPixel sfImage_setPixel;
	da_sfImage_getPixel sfImage_getPixel;
	da_sfImage_getPixelsPtr sfImage_getPixelsPtr;
	da_sfImage_flipHorizontally sfImage_flipHorizontally;
	da_sfImage_flipVertically sfImage_flipVertically;
	da_sfFloatRect_contains sfFloatRect_contains;
	da_sfIntRect_contains sfIntRect_contains;
	da_sfFloatRect_intersects sfFloatRect_intersects;
	da_sfIntRect_intersects sfIntRect_intersects;
	da_sfRectangleShape_create sfRectangleShape_create;
	da_sfRectangleShape_copy sfRectangleShape_copy;
	da_sfRectangleShape_destroy sfRectangleShape_destroy;
	da_sfRectangleShape_setPosition sfRectangleShape_setPosition;
	da_sfRectangleShape_setRotation sfRectangleShape_setRotation;
	da_sfRectangleShape_setScale sfRectangleShape_setScale;
	da_sfRectangleShape_setOrigin sfRectangleShape_setOrigin;
	da_sfRectangleShape_getPosition sfRectangleShape_getPosition;
	da_sfRectangleShape_getRotation sfRectangleShape_getRotation;
	da_sfRectangleShape_getScale sfRectangleShape_getScale;
	da_sfRectangleShape_getOrigin sfRectangleShape_getOrigin;
	da_sfRectangleShape_move sfRectangleShape_move;
	da_sfRectangleShape_rotate sfRectangleShape_rotate;
	da_sfRectangleShape_scale sfRectangleShape_scale;
	da_sfRectangleShape_getTransform sfRectangleShape_getTransform;
	da_sfRectangleShape_getInverseTransform sfRectangleShape_getInverseTransform;
	da_sfRectangleShape_setTexture sfRectangleShape_setTexture;
	da_sfRectangleShape_setTextureRect sfRectangleShape_setTextureRect;
	da_sfRectangleShape_setFillColor sfRectangleShape_setFillColor;
	da_sfRectangleShape_setOutlineColor sfRectangleShape_setOutlineColor;
	da_sfRectangleShape_setOutlineThickness sfRectangleShape_setOutlineThickness;
	da_sfRectangleShape_getTexture sfRectangleShape_getTexture;
	da_sfRectangleShape_getTextureRect sfRectangleShape_getTextureRect;
	da_sfRectangleShape_getFillColor sfRectangleShape_getFillColor;
	da_sfRectangleShape_getOutlineColor sfRectangleShape_getOutlineColor;
	da_sfRectangleShape_getOutlineThickness sfRectangleShape_getOutlineThickness;
	da_sfRectangleShape_getPointCount sfRectangleShape_getPointCount;
	da_sfRectangleShape_getPoint sfRectangleShape_getPoint;
	da_sfRectangleShape_setSize sfRectangleShape_setSize;
	da_sfRectangleShape_getSize sfRectangleShape_getSize;
	da_sfRectangleShape_getLocalBounds sfRectangleShape_getLocalBounds;
	da_sfRectangleShape_getGlobalBounds sfRectangleShape_getGlobalBounds;
	da_sfRenderTexture_create sfRenderTexture_create;
	da_sfRenderTexture_destroy sfRenderTexture_destroy;
	da_sfRenderTexture_getSize sfRenderTexture_getSize;
	da_sfRenderTexture_setActive sfRenderTexture_setActive;
	da_sfRenderTexture_display sfRenderTexture_display;
	da_sfRenderTexture_clear sfRenderTexture_clear;
	da_sfRenderTexture_setView sfRenderTexture_setView;
	da_sfRenderTexture_getView sfRenderTexture_getView;
	da_sfRenderTexture_getDefaultView sfRenderTexture_getDefaultView;
	da_sfRenderTexture_getViewport sfRenderTexture_getViewport;
	da_sfRenderTexture_mapPixelToCoords sfRenderTexture_mapPixelToCoords;
	da_sfRenderTexture_mapPixelToCoords sfRenderTexture_mapCoordsToPixel;
	da_sfRenderTexture_drawSprite sfRenderTexture_drawSprite;
	da_sfRenderTexture_drawText sfRenderTexture_drawText;
	da_sfRenderTexture_drawShape sfRenderTexture_drawShape;
	da_sfRenderTexture_drawCircleShape sfRenderTexture_drawCircleShape;
	da_sfRenderTexture_drawConvexShape sfRenderTexture_drawConvexShape;
	da_sfRenderTexture_drawRectangleShape sfRenderTexture_drawRectangleShape;
	da_sfRenderTexture_drawVertexArray sfRenderTexture_drawVertexArray;
	da_sfRenderTexture_drawPrimitives sfRenderTexture_drawPrimitives;
	da_sfRenderTexture_pushGLStates sfRenderTexture_pushGLStates;
	da_sfRenderTexture_popGLStates sfRenderTexture_popGLStates;
	da_sfRenderTexture_resetGLStates sfRenderTexture_resetGLStates;
	da_sfRenderTexture_getTexture sfRenderTexture_getTexture;
	da_sfRenderTexture_setSmooth sfRenderTexture_setSmooth;
	da_sfRenderTexture_isSmooth sfRenderTexture_isSmooth;
	da_sfRenderWindow_create sfRenderWindow_create;
	da_sfRenderWindow_createFromHandle sfRenderWindow_createFromHandle;
	da_sfRenderWindow_destroy sfRenderWindow_destroy;
	da_sfRenderWindow_close sfRenderWindow_close;
	da_sfRenderWindow_isOpen sfRenderWindow_isOpen;
	da_sfRenderWindow_getSettings sfRenderWindow_getSettings;
	da_sfRenderWindow_pollEvent sfRenderWindow_pollEvent;
	da_sfRenderWindow_waitEvent sfRenderWindow_waitEvent;
	da_sfRenderWindow_getPosition sfRenderWindow_getPosition;
	da_sfRenderWindow_setPosition sfRenderWindow_setPosition;
	da_sfRenderWindow_getSize sfRenderWindow_getSize;
	da_sfRenderWindow_setSize sfRenderWindow_setSize;
	da_sfRenderWindow_setTitle sfRenderWindow_setTitle;
	da_sfRenderWindow_setIcon sfRenderWindow_setIcon;
	da_sfRenderWindow_setVisible sfRenderWindow_setVisible;
	da_sfRenderWindow_setMouseCursorVisible sfRenderWindow_setMouseCursorVisible;
	da_sfRenderWindow_setVerticalSyncEnabled sfRenderWindow_setVerticalSyncEnabled;
	da_sfRenderWindow_setKeyRepeatEnabled sfRenderWindow_setKeyRepeatEnabled;
	da_sfRenderWindow_setActive sfRenderWindow_setActive;
	da_sfRenderWindow_display sfRenderWindow_display;
	da_sfRenderWindow_setFramerateLimit sfRenderWindow_setFramerateLimit;
	da_sfRenderWindow_setJoystickThreshold sfRenderWindow_setJoystickThreshold;
	da_sfRenderWindow_getSystemHandle sfRenderWindow_getSystemHandle;
	da_sfRenderWindow_clear sfRenderWindow_clear;
	da_sfRenderWindow_setView sfRenderWindow_setView;
	da_sfRenderWindow_getView sfRenderWindow_getView;
	da_sfRenderWindow_getDefaultView sfRenderWindow_getDefaultView;
	da_sfRenderWindow_getViewport sfRenderWindow_getViewport;
	da_sfRenderWindow_mapPixelToCoords sfRenderWindow_mapPixelToCoords;
	da_sfRenderWindow_mapCoordsToPixel sfRenderWindow_mapCoordsToPixel;
	da_sfRenderWindow_drawSprite sfRenderWindow_drawSprite;
	da_sfRenderWindow_drawText sfRenderWindow_drawText;
	da_sfRenderWindow_drawShape sfRenderWindow_drawShape;
	da_sfRenderWindow_drawCircleShape sfRenderWindow_drawCircleShape;
	da_sfRenderWindow_drawConvexShape sfRenderWindow_drawConvexShape;
	da_sfRenderWindow_drawRectangleShape sfRenderWindow_drawRectangleShape;
	da_sfRenderWindow_drawVertexArray sfRenderWindow_drawVertexArray;
	da_sfRenderWindow_drawPrimitives sfRenderWindow_drawPrimitives;
	da_sfRenderWindow_pushGLStates sfRenderWindow_pushGLStates;
	da_sfRenderWindow_popGLStates sfRenderWindow_popGLStates;
	da_sfRenderWindow_resetGLStates sfRenderWindow_resetGLStates;
	da_sfRenderWindow_capture sfRenderWindow_capture;
	da_sfMouse_getPositionRenderWindow sfMouse_getPositionRenderWindow;
	da_sfMouse_setPositionRenderWindow sfMouse_setPositionRenderWindow;
	da_sfShader_createFromFile sfShader_createFromFile;
	da_sfShader_createFromMemory sfShader_createFromMemory;
	da_sfShader_createFromStream sfShader_createFromStream;
	da_sfShader_destroy sfShader_destroy;
	da_sfShader_setFloatParameter sfShader_setFloatParameter;
	da_sfShader_setFloat2Parameter sfShader_setFloat2Parameter;
	da_sfShader_setFloat3Parameter sfShader_setFloat3Parameter;
	da_sfShader_setFloat4Parameter sfShader_setFloat4Parameter;
	da_sfShader_setVector2Parameter sfShader_setVector2Parameter;
	da_sfShader_setVector3Parameter sfShader_setVector3Parameter;
	da_sfShader_setColorParameter sfShader_setColorParameter;
	da_sfShader_setTransformParameter sfShader_setTransformParameter;
	da_sfShader_setTextureParameter sfShader_setTextureParameter;
	da_sfShader_setCurrentTextureParameter sfShader_setCurrentTextureParameter;
	da_sfShader_bind sfShader_bind;
	da_sfShader_isAvailable sfShader_isAvailable;
	da_sfShape_create sfShape_create;
	da_sfShape_destroy sfShape_destroy;
	da_sfShape_setPosition sfShape_setPosition;
	da_sfShape_setRotation sfShape_setRotation;
	da_sfShape_setScale sfShape_setScale;
	da_sfShape_setOrigin sfShape_setOrigin;
	da_sfShape_getPosition sfShape_getPosition;
	da_sfShape_getRotation sfShape_getRotation;
	da_sfShape_getScale sfShape_getScale;
	da_sfShape_getOrigin sfShape_getOrigin;
	da_sfShape_move sfShape_move;
	da_sfShape_rotate sfShape_rotate;
	da_sfShape_scale sfShape_scale;
	da_sfShape_getTransform sfShape_getTransform;
	da_sfShape_getInverseTransform sfShape_getInverseTransform;
	da_sfShape_setTexture sfShape_setTexture;
	da_sfShape_setTextureRect sfShape_setTextureRect;
	da_sfShape_setFillColor sfShape_setFillColor;
	da_sfShape_setOutlineColor sfShape_setOutlineColor;
	da_sfShape_setOutlineThickness sfShape_setOutlineThickness;
	da_sfShape_getTexture sfShape_getTexture;
	da_sfShape_getTextureRect sfShape_getTextureRect;
	da_sfShape_getFillColor sfShape_getFillColor;
	da_sfShape_getOutlineColor sfShape_getOutlineColor;
	da_sfShape_getOutlineThickness sfShape_getOutlineThickness;
	da_sfShape_getPointCount sfShape_getPointCount;
	da_sfShape_getPoint sfShape_getPoint;
	da_sfShape_getLocalBounds sfShape_getLocalBounds;
	da_sfShape_getGlobalBounds sfShape_getGlobalBounds;
	da_sfShape_update sfShape_update;
	da_sfSprite_create sfSprite_create;
	da_sfSprite_copy sfSprite_copy;
	da_sfSprite_destroy sfSprite_destroy;
	da_sfSprite_setPosition sfSprite_setPosition;
	da_sfSprite_setRotation sfSprite_setRotation;
	da_sfSprite_setScale sfSprite_setScale;
	da_sfSprite_setOrigin sfSprite_setOrigin;
	da_sfSprite_getPosition sfSprite_getPosition;
	da_sfSprite_getRotation sfSprite_getRotation;
	da_sfSprite_getScale sfSprite_getScale;
	da_sfSprite_getOrigin sfSprite_getOrigin;
	da_sfSprite_move sfSprite_move;
	da_sfSprite_rotate sfSprite_rotate;
	da_sfSprite_scale sfSprite_scale;
	da_sfSprite_getTransform sfSprite_getTransform;
	da_sfSprite_getInverseTransform sfSprite_getInverseTransform;
	da_sfSprite_setTexture sfSprite_setTexture;
	da_sfSprite_setTextureRect sfSprite_setTextureRect;
	da_sfSprite_setColor sfSprite_setColor;
	da_sfSprite_getTexture sfSprite_getTexture;
	da_sfSprite_getTextureRect sfSprite_getTextureRect;
	da_sfSprite_getColor sfSprite_getColor;
	da_sfSprite_getLocalBounds sfSprite_getLocalBounds;
	da_sfSprite_getGlobalBounds sfSprite_getGlobalBounds;
	da_sfText_create sfText_create;
	da_sfText_copy sfText_copy;
	da_sfText_destroy sfText_destroy;
	da_sfText_setPosition sfText_setPosition;
	da_sfText_setRotation sfText_setRotation;
	da_sfText_setScale sfText_setScale;
	da_sfText_setOrigin sfText_setOrigin;
	da_sfText_getPosition sfText_getPosition;
	da_sfText_getRotation sfText_getRotation;
	da_sfText_getScale sfText_getScale;
	da_sfText_getOrigin sfText_getOrigin;
	da_sfText_move sfText_move;
	da_sfText_rotate sfText_rotate;
	da_sfText_scale sfText_scale;
	da_sfText_getTransform sfText_getTransform;
	da_sfText_getInverseTransform sfText_getInverseTransform;
	da_sfText_setString sfText_setString;
	da_sfText_setUnicodeString sfText_setUnicodeString;
	da_sfText_setFont sfText_setFont;
	da_sfText_setCharacterSize sfText_setCharacterSize;
	da_sfText_setStyle sfText_setStyle;
	da_sfText_setColor sfText_setColor;
	da_sfText_getString sfText_getString;
	da_sfText_getUnicodeString sfText_getUnicodeString;
	da_sfText_getFont sfText_getFont;
	da_sfText_getCharacterSize sfText_getCharacterSize;
	da_sfText_getStyle sfText_getStyle;
	da_sfText_getColor sfText_getColor;
	da_sfText_findCharacterPos sfText_findCharacterPos;
	da_sfText_getLocalBounds sfText_getLocalBounds;
	da_sfText_getGlobalBounds sfText_getGlobalBounds;
	da_sfTexture_create sfTexture_create;
	da_sfTexture_createFromFile sfTexture_createFromFile;
	da_sfTexture_createFromMemory sfTexture_createFromMemory;
	da_sfTexture_createFromStream sfTexture_createFromStream;
	da_sfTexture_createFromImage sfTexture_createFromImage;
	da_sfTexture_copy sfTexture_copy;
	da_sfTexture_destroy sfTexture_destroy;
	da_sfTexture_getSize sfTexture_getSize;
	da_sfTexture_copyToImage sfTexture_copyToImage;
	da_sfTexture_updateFromPixels sfTexture_updateFromPixels;
	da_sfTexture_updateFromImage sfTexture_updateFromImage;
	da_sfTexture_updateFromWindow sfTexture_updateFromWindow;
	da_sfTexture_updateFromRenderWindow sfTexture_updateFromRenderWindow;
	da_sfTexture_bind sfTexture_bind;
	da_sfTexture_setSmooth sfTexture_setSmooth;
	da_sfTexture_isSmooth sfTexture_isSmooth;
	da_sfTexture_setRepeated sfTexture_setRepeated;
	da_sfTexture_isRepeated sfTexture_isRepeated;
	da_sfTexture_getMaximumSize sfTexture_getMaximumSize;
	da_sfTransform_fromMatrix sfTransform_fromMatrix;
	da_sfTransform_getMatrix sfTransform_getMatrix;
	da_sfTransform_getInverse sfTransform_getInverse;
	da_sfTransform_transformPoint sfTransform_transformPoint;
	da_sfTransform_transformRect sfTransform_transformRect;
	da_sfTransform_combine sfTransform_combine;
	da_sfTransform_translate sfTransform_translate;
	da_sfTransform_rotate sfTransform_rotate;
	da_sfTransform_rotateWithCenter sfTransform_rotateWithCenter;
	da_sfTransform_scale sfTransform_scale;
	da_sfTransform_scaleWithCenter sfTransform_scaleWithCenter;
	da_sfTransformable_create sfTransformable_create;
	da_sfTransformable_copy sfTransformable_copy;
	da_sfTransformable_destroy sfTransformable_destroy;
	da_sfTransformable_setPosition sfTransformable_setPosition;
	da_sfTransformable_setRotation sfTransformable_setRotation;
	da_sfTransformable_setScale sfTransformable_setScale;
	da_sfTransformable_setOrigin sfTransformable_setOrigin;
	da_sfTransformable_getPosition sfTransformable_getPosition;
	da_sfTransformable_getRotation sfTransformable_getRotation;
	da_sfTransformable_getScale sfTransformable_getScale;
	da_sfTransformable_getOrigin sfTransformable_getOrigin;
	da_sfTransformable_move sfTransformable_move;
	da_sfTransformable_rotate sfTransformable_rotate;
	da_sfTransformable_scale sfTransformable_scale;
	da_sfTransformable_getTransform sfTransformable_getTransform;
	da_sfTransformable_getInverseTransform sfTransformable_getInverseTransform;
	da_sfVertexArray_create sfVertexArray_create;
	da_sfVertexArray_copy sfVertexArray_copy;
	da_sfVertexArray_destroy sfVertexArray_destroy;
	da_sfVertexArray_getVertexCount sfVertexArray_getVertexCount;
	da_sfVertexArray_getVertex sfVertexArray_getVertex;
	da_sfVertexArray_clear sfVertexArray_clear;
	da_sfVertexArray_resize sfVertexArray_resize;
	da_sfVertexArray_append sfVertexArray_append;
	da_sfVertexArray_setPrimitiveType sfVertexArray_setPrimitiveType;
	da_sfVertexArray_getPrimitiveType sfVertexArray_getPrimitiveType;
	da_sfVertexArray_getBounds sfVertexArray_getBounds;
	da_sfView_create sfView_create;
	da_sfView_createFromRect sfView_createFromRect;
	da_sfView_copy sfView_copy;
	da_sfView_destroy sfView_destroy;
	da_sfView_setCenter sfView_setCenter;
	da_sfView_setSize sfView_setSize;
	da_sfView_setRotation sfView_setRotation;
	da_sfView_setViewport sfView_setViewport;
	da_sfView_reset sfView_reset;
	da_sfView_getCenter sfView_getCenter;
	da_sfView_getSize sfView_getSize;
	da_sfView_getRotation sfView_getRotation;
	da_sfView_getViewport sfView_getViewport;
	da_sfView_move sfView_move;
	da_sfView_rotate sfView_rotate;
	da_sfView_zoom sfView_zoom;
}
class DerelictSFML2GraphicsLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();


}
__gshared DerelictSFML2GraphicsLoader DerelictSFML2Graphics;

shared static this();
