// D import file generated from 'derelict/sfml2/network.d'
module derelict.sfml2.network;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sfml2.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-network-2.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-network.2.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-network.so.2";
			}
			else
			{
				static assert(0, "Need to implement SFML2 Network libNames for this operating system.");
			}
		}
	}
}
struct sfFtpDirectoryResponse;
struct sfFtpListingResponse;
struct sfFtpResponse;
struct sfFtp;
struct sfHttpRequest;
struct sfHttpResponse;
struct sfHttp;
struct sfPacket;
struct sfSocketSelector;
struct sfTcpListener;
struct sfTcpSocket;
struct sfUdpSocket;
alias int sfFtpTransferMode;
enum 
{
	sfFtpBinary,
	sfFtpAscii,
	sfFtpEbcdic,
}
alias int sfFtpStatus;
enum 
{
	sfFtpRestartMarkerReply = 110,
	sfFtpServiceReadySoon = 120,
	sfFtpDataConnectionAlreadyOpened = 125,
	sfFtpOpeningDataConnection = 150,
	sfFtpOk = 200,
	sfFtpPointlessCommand = 202,
	sfFtpSystemStatus = 211,
	sfFtpDirectoryStatus = 212,
	sfFtpFileStatus = 213,
	sfFtpHelpMessage = 214,
	sfFtpSystemType = 215,
	sfFtpServiceReady = 220,
	sfFtpClosingConnection = 221,
	sfFtpDataConnectionOpened = 225,
	sfFtpClosingDataConnection = 226,
	sfFtpEnteringPassiveMode = 227,
	sfFtpLoggedIn = 230,
	sfFtpFileActionOk = 250,
	sfFtpDirectoryOk = 257,
	sfFtpNeedPassword = 331,
	sfFtpNeedAccountToLogIn = 332,
	sfFtpNeedInformation = 350,
	sfFtpServiceUnavailable = 421,
	sfFtpDataConnectionUnavailable = 425,
	sfFtpTransferAborted = 426,
	sfFtpFileActionAborted = 450,
	sfFtpLocalError = 451,
	sfFtpInsufficientStorageSpace = 452,
	sfFtpCommandUnknown = 500,
	sfFtpParametersUnknown = 501,
	sfFtpCommandNotImplemented = 502,
	sfFtpBadCommandSequence = 503,
	sfFtpParameterNotImplemented = 504,
	sfFtpNotLoggedIn = 530,
	sfFtpNeedAccountToStore = 532,
	sfFtpFileUnavailable = 550,
	sfFtpPageTypeUnknown = 551,
	sfFtpNotEnoughMemory = 552,
	sfFtpFilenameNotAllowed = 553,
	sfFtpInvalidResponse = 1000,
	sfFtpConnectionFailed = 1001,
	sfFtpConnectionClosed = 1002,
	sfFtpInvalidFile = 1003,
}
alias int sfHttpMethod;
enum 
{
	sfHttpGet,
	sfHttpPost,
	sfHttpHead,
}
alias int sfHttpStatus;
enum 
{
	sfHttpOk = 200,
	sfHttpCreated = 201,
	sfHttpAccepted = 202,
	sfHttpNoContent = 204,
	sfHttpMultipleChoices = 300,
	sfHttpMovedPermanently = 301,
	sfHttpMovedTemporarily = 302,
	sfHttpNotModified = 304,
	sfHttpBadRequest = 400,
	sfHttpUnauthorized = 401,
	sfHttpForbidden = 403,
	sfHttpNotFound = 404,
	sfHttpInternalServerError = 500,
	sfHttpNotImplemented = 501,
	sfHttpBadGateway = 502,
	sfHttpServiceNotAvailable = 503,
	sfHttpInvalidResponse = 1000,
	sfHttpConnectionFailed = 1001,
}
struct sfIpAddress
{
	char[16] address;
}
immutable(sfIpAddress) sfIpAddress_None;
alias int sfSocketStatus;
enum 
{
	sfSocketDone,
	sfSocketNotReady,
	sfSocketDisconnected,
	sfSocketError,
}
extern (C) nothrow 
{
	alias void function(sfFtpListingResponse* ftpListingResponse) da_sfFtpListingResponse_destroy;
	alias sfBool function(const(sfFtpListingResponse)* ftpListingResponse) da_sfFtpListingResponse_isOk;
	alias sfFtpStatus function(const(sfFtpListingResponse)* ftpListingResponse) da_sfFtpListingResponse_getStatus;
	alias const(char)* function(const(sfFtpListingResponse)* ftpListingResponse) da_sfFtpListingResponse_getMessage;
	alias size_t function(const(sfFtpListingResponse)* ftpListingResponse) da_sfFtpListingResponse_getCount;
	alias const(char)* function(const(sfFtpListingResponse)* ftpListingResponse, size_t index) da_sfFtpListingResponse_getName;
	alias void function(sfFtpDirectoryResponse* ftpDirectoryResponse) da_sfFtpDirectoryResponse_destroy;
	alias sfBool function(const(sfFtpDirectoryResponse)* ftpDirectoryResponse) da_sfFtpDirectoryResponse_isOk;
	alias sfFtpStatus function(const(sfFtpDirectoryResponse)* ftpDirectoryResponse) da_sfFtpDirectoryResponse_getStatus;
	alias const(char)* function(const(sfFtpDirectoryResponse)* ftpDirectoryResponse) da_sfFtpDirectoryResponse_getMessage;
	alias const(char)* function(const(sfFtpDirectoryResponse)* ftpDirectoryResponse) da_sfFtpDirectoryResponse_getDirectory;
	alias void function(sfFtpResponse* ftpResponse) da_sfFtpResponse_destroy;
	alias sfBool function(const(sfFtpResponse)* ftpResponse) da_sfFtpResponse_isOk;
	alias sfFtpStatus function(const(sfFtpResponse)* ftpResponse) da_sfFtpResponse_getStatus;
	alias const(char)* function(const(sfFtpResponse)* ftpResponse) da_sfFtpResponse_getMessage;
	alias sfFtp* function() da_sfFtp_create;
	alias void function(sfFtp* ftp) da_sfFtp_destroy;
	alias sfFtpResponse* function(sfFtp* ftp, sfIpAddress server, ushort port, sfTime timeout) da_sfFtp_connect;
	alias sfFtpResponse* function(sfFtp* ftp) da_sfFtp_loginAnonymous;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* userName, const(char)* password) da_sfFtp_login;
	alias sfFtpResponse* function(sfFtp* ftp) da_sfFtp_disconnect;
	alias sfFtpResponse* function(sfFtp* ftp) da_sfFtp_keepAlive;
	alias sfFtpDirectoryResponse* function(sfFtp* ftp) da_sfFtp_getWorkingDirectory;
	alias sfFtpListingResponse* function(sfFtp* ftp, const(char)* directory) da_sfFtp_getDirectoryListing;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* directory) da_sfFtp_changeDirectory;
	alias sfFtpResponse* function(sfFtp* ftp) da_sfFtp_parentDirectory;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* name) da_sfFtp_createDirectory;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* name) da_sfFtp_deleteDirectory;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* file, const(char)* newName) da_sfFtp_renameFile;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* name) da_sfFtp_deleteFile;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* distantFile, const(char)* destPath, sfFtpTransferMode mode) da_sfFtp_download;
	alias sfFtpResponse* function(sfFtp* ftp, const(char)* localFile, const(char)* destPath, sfFtpTransferMode mode) da_sfFtp_upload;
	alias sfHttpRequest* function() da_sfHttpRequest_create;
	alias void function(sfHttpRequest* httpRequest) da_sfHttpRequest_destroy;
	alias void function(sfHttpRequest* httpRequest, const(char)* field, const(char)* value) da_sfHttpRequest_setField;
	alias void function(sfHttpRequest* httpRequest, sfHttpMethod method) da_sfHttpRequest_setMethod;
	alias void function(sfHttpRequest* httpRequest, const(char)* uri) da_sfHttpRequest_setUri;
	alias void function(sfHttpRequest* httpRequest, uint major, uint minor) da_sfHttpRequest_setHttpVersion;
	alias void function(sfHttpRequest* httpRequest, const(char)* _body) da_sfHttpRequest_setBody;
	alias void function(sfHttpResponse* httpResponse) da_sfHttpResponse_destroy;
	alias const(char)* function(const(sfHttpResponse)* httpResponse, const(char)* field) da_sfHttpResponse_getField;
	alias sfHttpStatus function(const(sfHttpResponse)* httpResponse) da_sfHttpResponse_getStatus;
	alias uint function(const(sfHttpResponse)* httpResponse) da_sfHttpResponse_getMajorVersion;
	alias uint function(const(sfHttpResponse)* httpResponse) da_sfHttpResponse_getMinorVersion;
	alias const(char)* function(const(sfHttpResponse)* httpResponse) da_sfHttpResponse_getBody;
	alias sfHttp* function() da_sfHttp_create;
	alias void function(sfHttp* http) da_sfHttp_destroy;
	alias void function(sfHttp* http, const(char)* host, ushort port) da_sfHttp_setHost;
	alias sfHttpResponse* function(sfHttp* http, const(sfHttpRequest)* request, sfTime timeout) da_sfHttp_sendRequest;
	alias sfIpAddress function(const(char)* address) da_sfIpAddress_fromString;
	alias sfIpAddress function(sfUint8 byte0, sfUint8 byte1, sfUint8 byte2, sfUint8 byte3) da_sfIpAddress_fromBytes;
	alias sfIpAddress function(sfUint32 address) da_sfIpAddress_fromInteger;
	alias void function(sfIpAddress address, char* string) da_sfIpAddress_toString;
	alias sfUint32 function(sfIpAddress address) da_sfIpAddress_toInteger;
	alias sfIpAddress function() da_sfIpAddress_getLocalAddress;
	alias sfIpAddress function(sfTime timeout) da_sfIpAddress_getPublicAddress;
	alias sfPacket* function() da_sfPacket_create;
	alias sfPacket* function(const(sfPacket)* packet) da_sfPacket_copy;
	alias void function(sfPacket* packet) da_sfPacket_destroy;
	alias void function(sfPacket* packet, const(void)* data, size_t sizeInBytes) da_sfPacket_append;
	alias void function(sfPacket* packet) da_sfPacket_clear;
	alias const(void)* function(const(sfPacket)* packet) da_sfPacket_getData;
	alias size_t function(const(sfPacket)* packet) da_sfPacket_getDataSize;
	alias sfBool function(const(sfPacket)* packet) da_sfPacket_endOfPacket;
	alias sfBool function(const(sfPacket)* packet) da_sfPacket_canRead;
	alias sfBool function(sfPacket* packet) da_sfPacket_readBool;
	alias sfInt8 function(sfPacket* packet) da_sfPacket_readInt8;
	alias sfUint8 function(sfPacket* packet) da_sfPacket_readUint8;
	alias sfInt16 function(sfPacket* packet) da_sfPacket_readInt16;
	alias sfUint16 function(sfPacket* packet) da_sfPacket_readUint16;
	alias sfInt32 function(sfPacket* packet) da_sfPacket_readInt32;
	alias sfUint32 function(sfPacket* packet) da_sfPacket_readUint32;
	alias float function(sfPacket* packet) da_sfPacket_readFloat;
	alias double function(sfPacket* packet) da_sfPacket_readDouble;
	alias void function(sfPacket* packet, char* string) da_sfPacket_readString;
	alias void function(sfPacket* packet, wchar* string) da_sfPacket_readWideString;
	alias void function(sfPacket* packet, sfBool) da_sfPacket_writeBool;
	alias void function(sfPacket* packet, sfInt8) da_sfPacket_writeInt8;
	alias void function(sfPacket* packet, sfUint8) da_sfPacket_writeUint8;
	alias void function(sfPacket* packet, sfInt16) da_sfPacket_writeInt16;
	alias void function(sfPacket* packet, sfUint16) da_sfPacket_writeUint16;
	alias void function(sfPacket* packet, sfInt32) da_sfPacket_writeInt32;
	alias void function(sfPacket* packet, sfUint32) da_sfPacket_writeUint32;
	alias void function(sfPacket* packet, float) da_sfPacket_writeFloat;
	alias void function(sfPacket* packet, double) da_sfPacket_writeDouble;
	alias void function(sfPacket* packet, const(char)* string) da_sfPacket_writeString;
	alias void function(sfPacket* packet, const(wchar)* string) da_sfPacket_writeWideString;
	alias sfSocketSelector* function() da_sfSocketSelector_create;
	alias sfSocketSelector* function(const(sfSocketSelector)* selector) da_sfSocketSelector_copy;
	alias void function(sfSocketSelector* selector) da_sfSocketSelector_destroy;
	alias void function(sfSocketSelector* selector, sfTcpListener* socket) da_sfSocketSelector_addTcpListener;
	alias void function(sfSocketSelector* selector, sfTcpSocket* socket) da_sfSocketSelector_addTcpSocket;
	alias void function(sfSocketSelector* selector, sfUdpSocket* socket) da_sfSocketSelector_addUdpSocket;
	alias void function(sfSocketSelector* selector, sfTcpListener* socket) da_sfSocketSelector_removeTcpListener;
	alias void function(sfSocketSelector* selector, sfTcpSocket* socket) da_sfSocketSelector_removeTcpSocket;
	alias void function(sfSocketSelector* selector, sfUdpSocket* socket) da_sfSocketSelector_removeUdpSocket;
	alias void function(sfSocketSelector* selector) da_sfSocketSelector_clear;
	alias sfBool function(sfSocketSelector* selector, sfTime timeout) da_sfSocketSelector_wait;
	alias sfBool function(const(sfSocketSelector)* selector, sfTcpListener* socket) da_sfSocketSelector_isTcpListenerReady;
	alias sfBool function(const(sfSocketSelector)* selector, sfTcpSocket* socket) da_sfSocketSelector_isTcpSocketReady;
	alias sfBool function(const(sfSocketSelector)* selector, sfUdpSocket* socket) da_sfSocketSelector_isUdpSocketReady;
	alias sfTcpListener* function() da_sfTcpListener_create;
	alias void function(sfTcpListener* listener) da_sfTcpListener_destroy;
	alias void function(sfTcpListener* listener, sfBool blocking) da_sfTcpListener_setBlocking;
	alias sfBool function(const(sfTcpListener)* listener) da_sfTcpListener_isBlocking;
	alias ushort function(const(sfTcpListener)* listener) da_sfTcpListener_getLocalPort;
	alias sfSocketStatus function(sfTcpListener* listener, ushort port) da_sfTcpListener_listen;
	alias sfSocketStatus function(sfTcpListener* listener, sfTcpSocket** connected) da_sfTcpListener_accept;
	alias sfTcpSocket* function() da_sfTcpSocket_create;
	alias void function(sfTcpSocket* socket) da_sfTcpSocket_destroy;
	alias void function(sfTcpSocket* socket, sfBool blocking) da_sfTcpSocket_setBlocking;
	alias sfBool function(const(sfTcpSocket)* socket) da_sfTcpSocket_isBlocking;
	alias ushort function(const(sfTcpSocket)* socket) da_sfTcpSocket_getLocalPort;
	alias sfIpAddress function(const(sfTcpSocket)* socket) da_sfTcpSocket_getRemoteAddress;
	alias ushort function(const(sfTcpSocket)* socket) da_sfTcpSocket_getRemotePort;
	alias sfSocketStatus function(sfTcpSocket* socket, sfIpAddress host, ushort port, sfTime timeout) da_sfTcpSocket_connect;
	alias void function(sfTcpSocket* socket) da_sfTcpSocket_disconnect;
	alias sfSocketStatus function(sfTcpSocket* socket, const(void)* data, size_t size) da_sfTcpSocket_send;
	alias sfSocketStatus function(sfTcpSocket* socket, void* data, size_t maxSize, size_t* sizeReceived) da_sfTcpSocket_receive;
	alias sfSocketStatus function(sfTcpSocket* socket, sfPacket* packet) da_sfTcpSocket_sendPacket;
	alias sfSocketStatus function(sfTcpSocket* socket, sfPacket* packet) da_sfTcpSocket_receivePacket;
	alias sfUdpSocket* function() da_sfUdpSocket_create;
	alias void function(sfUdpSocket* socket) da_sfUdpSocket_destroy;
	alias void function(sfUdpSocket* socket, sfBool blocking) da_sfUdpSocket_setBlocking;
	alias sfBool function(const(sfUdpSocket)* socket) da_sfUdpSocket_isBlocking;
	alias short function(const(sfUdpSocket)* socket) da_sfUdpSocket_getLocalPort;
	alias sfSocketStatus function(sfUdpSocket* socket, ushort port) da_sfUdpSocket_bind;
	alias void function(sfUdpSocket* socket) da_sfUdpSocket_unbind;
	alias sfSocketStatus function(sfUdpSocket* socket, const(void)* data, size_t size, sfIpAddress address, ushort port) da_sfUdpSocket_send;
	alias sfSocketStatus function(sfUdpSocket* socket, void* data, size_t maxSize, size_t* sizeReceived, sfIpAddress* address, ushort* port) da_sfUdpSocket_receive;
	alias sfSocketStatus function(sfUdpSocket* socket, sfPacket* packet, sfIpAddress address, ushort port) da_sfUdpSocket_sendPacket;
	alias sfSocketStatus function(sfUdpSocket* socket, sfPacket* packet, sfIpAddress* address, ushort* port) da_sfUdpSocket_receivePacket;
	alias uint function() da_sfUdpSocket_maxDatagramSize;
}

__gshared 
{
	da_sfFtpListingResponse_destroy sfFtpListingResponse_destroy;
	da_sfFtpListingResponse_isOk sfFtpListingResponse_isOk;
	da_sfFtpListingResponse_getStatus sfFtpListingResponse_getStatus;
	da_sfFtpListingResponse_getMessage sfFtpListingResponse_getMessage;
	da_sfFtpListingResponse_getCount sfFtpListingResponse_getCount;
	da_sfFtpListingResponse_getName sfFtpListingResponse_getName;
	da_sfFtpDirectoryResponse_destroy sfFtpDirectoryResponse_destroy;
	da_sfFtpDirectoryResponse_isOk sfFtpDirectoryResponse_isOk;
	da_sfFtpDirectoryResponse_getStatus sfFtpDirectoryResponse_getStatus;
	da_sfFtpDirectoryResponse_getMessage sfFtpDirectoryResponse_getMessage;
	da_sfFtpDirectoryResponse_getDirectory sfFtpDirectoryResponse_getDirectory;
	da_sfFtpResponse_destroy sfFtpResponse_destroy;
	da_sfFtpResponse_isOk sfFtpResponse_isOk;
	da_sfFtpResponse_getStatus sfFtpResponse_getStatus;
	da_sfFtpResponse_getMessage sfFtpResponse_getMessage;
	da_sfFtp_create sfFtp_create;
	da_sfFtp_destroy sfFtp_destroy;
	da_sfFtp_connect sfFtp_connect;
	da_sfFtp_loginAnonymous sfFtp_loginAnonymous;
	da_sfFtp_login sfFtp_login;
	da_sfFtp_disconnect sfFtp_disconnect;
	da_sfFtp_keepAlive sfFtp_keepAlive;
	da_sfFtp_getWorkingDirectory sfFtp_getWorkingDirectory;
	da_sfFtp_getDirectoryListing sfFtp_getDirectoryListing;
	da_sfFtp_changeDirectory sfFtp_changeDirectory;
	da_sfFtp_parentDirectory sfFtp_parentDirectory;
	da_sfFtp_createDirectory sfFtp_createDirectory;
	da_sfFtp_deleteDirectory sfFtp_deleteDirectory;
	da_sfFtp_renameFile sfFtp_renameFile;
	da_sfFtp_deleteFile sfFtp_deleteFile;
	da_sfFtp_download sfFtp_download;
	da_sfFtp_upload sfFtp_upload;
	da_sfHttpRequest_create sfHttpRequest_create;
	da_sfHttpRequest_destroy sfHttpRequest_destroy;
	da_sfHttpRequest_setField sfHttpRequest_setField;
	da_sfHttpRequest_setMethod sfHttpRequest_setMethod;
	da_sfHttpRequest_setUri sfHttpRequest_setUri;
	da_sfHttpRequest_setHttpVersion sfHttpRequest_setHttpVersion;
	da_sfHttpRequest_setBody sfHttpRequest_setBody;
	da_sfHttpResponse_destroy sfHttpResponse_destroy;
	da_sfHttpResponse_getField sfHttpResponse_getField;
	da_sfHttpResponse_getStatus sfHttpResponse_getStatus;
	da_sfHttpResponse_getMajorVersion sfHttpResponse_getMajorVersion;
	da_sfHttpResponse_getMinorVersion sfHttpResponse_getMinorVersion;
	da_sfHttpResponse_getBody sfHttpResponse_getBody;
	da_sfHttp_create sfHttp_create;
	da_sfHttp_destroy sfHttp_destroy;
	da_sfHttp_setHost sfHttp_setHost;
	da_sfHttp_sendRequest sfHttp_sendRequest;
	da_sfIpAddress_fromString sfIpAddress_fromString;
	da_sfIpAddress_fromBytes sfIpAddress_fromBytes;
	da_sfIpAddress_fromInteger sfIpAddress_fromInteger;
	da_sfIpAddress_toString sfIpAddress_toString;
	da_sfIpAddress_toInteger sfIpAddress_toInteger;
	da_sfIpAddress_getLocalAddress sfIpAddress_getLocalAddress;
	da_sfIpAddress_getPublicAddress sfIpAddress_getPublicAddress;
	da_sfPacket_create sfPacket_create;
	da_sfPacket_copy sfPacket_copy;
	da_sfPacket_destroy sfPacket_destroy;
	da_sfPacket_append sfPacket_append;
	da_sfPacket_clear sfPacket_clear;
	da_sfPacket_getData sfPacket_getData;
	da_sfPacket_getDataSize sfPacket_getDataSize;
	da_sfPacket_endOfPacket sfPacket_endOfPacket;
	da_sfPacket_canRead sfPacket_canRead;
	da_sfPacket_readBool sfPacket_readBool;
	da_sfPacket_readInt8 sfPacket_readInt8;
	da_sfPacket_readUint8 sfPacket_readUint8;
	da_sfPacket_readInt16 sfPacket_readInt16;
	da_sfPacket_readUint16 sfPacket_readUint16;
	da_sfPacket_readInt32 sfPacket_readInt32;
	da_sfPacket_readUint32 sfPacket_readUint32;
	da_sfPacket_readFloat sfPacket_readFloat;
	da_sfPacket_readDouble sfPacket_readDouble;
	da_sfPacket_readString sfPacket_readString;
	da_sfPacket_readWideString sfPacket_readWideString;
	da_sfPacket_writeBool sfPacket_writeBool;
	da_sfPacket_writeInt8 sfPacket_writeInt8;
	da_sfPacket_writeUint8 sfPacket_writeUint8;
	da_sfPacket_writeInt16 sfPacket_writeInt16;
	da_sfPacket_writeUint16 sfPacket_writeUint16;
	da_sfPacket_writeInt32 sfPacket_writeInt32;
	da_sfPacket_writeUint32 sfPacket_writeUint32;
	da_sfPacket_writeFloat sfPacket_writeFloat;
	da_sfPacket_writeDouble sfPacket_writeDouble;
	da_sfPacket_writeString sfPacket_writeString;
	da_sfPacket_writeWideString sfPacket_writeWideString;
	da_sfSocketSelector_create sfSocketSelector_create;
	da_sfSocketSelector_copy sfSocketSelector_copy;
	da_sfSocketSelector_destroy sfSocketSelector_destroy;
	da_sfSocketSelector_addTcpListener sfSocketSelector_addTcpListener;
	da_sfSocketSelector_addTcpSocket sfSocketSelector_addTcpSocket;
	da_sfSocketSelector_addUdpSocket sfSocketSelector_addUdpSocket;
	da_sfSocketSelector_removeTcpListener sfSocketSelector_removeTcpListener;
	da_sfSocketSelector_removeTcpSocket sfSocketSelector_removeTcpSocket;
	da_sfSocketSelector_removeUdpSocket sfSocketSelector_removeUdpSocket;
	da_sfSocketSelector_clear sfSocketSelector_clear;
	da_sfSocketSelector_wait sfSocketSelector_wait;
	da_sfSocketSelector_isTcpListenerReady sfSocketSelector_isTcpListenerReady;
	da_sfSocketSelector_isTcpSocketReady sfSocketSelector_isTcpSocketReady;
	da_sfSocketSelector_isUdpSocketReady sfSocketSelector_isUdpSocketReady;
	da_sfTcpListener_create sfTcpListener_create;
	da_sfTcpListener_destroy sfTcpListener_destroy;
	da_sfTcpListener_setBlocking sfTcpListener_setBlocking;
	da_sfTcpListener_isBlocking sfTcpListener_isBlocking;
	da_sfTcpListener_getLocalPort sfTcpListener_getLocalPort;
	da_sfTcpListener_listen sfTcpListener_listen;
	da_sfTcpListener_accept sfTcpListener_accept;
	da_sfTcpSocket_create sfTcpSocket_create;
	da_sfTcpSocket_destroy sfTcpSocket_destroy;
	da_sfTcpSocket_setBlocking sfTcpSocket_setBlocking;
	da_sfTcpSocket_isBlocking sfTcpSocket_isBlocking;
	da_sfTcpSocket_getLocalPort sfTcpSocket_getLocalPort;
	da_sfTcpSocket_getRemoteAddress sfTcpSocket_getRemoteAddress;
	da_sfTcpSocket_getRemotePort sfTcpSocket_getRemotePort;
	da_sfTcpSocket_connect sfTcpSocket_connect;
	da_sfTcpSocket_disconnect sfTcpSocket_disconnect;
	da_sfTcpSocket_send sfTcpSocket_send;
	da_sfTcpSocket_receive sfTcpSocket_receive;
	da_sfTcpSocket_sendPacket sfTcpSocket_sendPacket;
	da_sfTcpSocket_receivePacket sfTcpSocket_receivePacket;
	da_sfUdpSocket_create sfUdpSocket_create;
	da_sfUdpSocket_destroy sfUdpSocket_destroy;
	da_sfUdpSocket_setBlocking sfUdpSocket_setBlocking;
	da_sfUdpSocket_isBlocking sfUdpSocket_isBlocking;
	da_sfUdpSocket_getLocalPort sfUdpSocket_getLocalPort;
	da_sfUdpSocket_bind sfUdpSocket_bind;
	da_sfUdpSocket_unbind sfUdpSocket_unbind;
	da_sfUdpSocket_send sfUdpSocket_send;
	da_sfUdpSocket_receive sfUdpSocket_receive;
	da_sfUdpSocket_sendPacket sfUdpSocket_sendPacket;
	da_sfUdpSocket_receivePacket sfUdpSocket_receivePacket;
	da_sfUdpSocket_maxDatagramSize sfUdpSocket_maxDatagramSize;
}
class DerelictSFML2NetworkLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();


}
__gshared DerelictSFML2NetworkLoader DerelictSFML2Network;

shared static this();
