// D import file generated from 'derelict/sfml2/window.d'
module derelict.sfml2.window;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sfml2.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-window-2.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-window.2.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-window.so.2";
			}
			else
			{
				static assert(0, "Need to implement SFML2 Window libNames for this operating system.");
			}
		}
	}
}
struct sfContext;
struct sfWindow;
alias int sfEventType;
enum 
{
	sfEvtClosed,
	sfEvtResized,
	sfEvtLostFocus,
	sfEvtGainedFocus,
	sfEvtTextEntered,
	sfEvtKeyPressed,
	sfEvtKeyReleased,
	sfEvtMouseWheelMoved,
	sfEvtMouseButtonPressed,
	sfEvtMouseButtonReleased,
	sfEvtMouseMoved,
	sfEvtMouseEntered,
	sfEvtMouseLeft,
	sfEvtJoystickButtonPressed,
	sfEvtJoystickButtonReleased,
	sfEvtJoystickMoved,
	sfEvtJoystickConnected,
	sfEvtJoystickDisconnected,
}
struct sfKeyEvent
{
	sfEventType type;
	sfKeyCode code;
	sfBool alt;
	sfBool control;
	sfBool shift;
	sfBool system;
}
struct sfTextEvent
{
	sfEventType type;
	sfUint32 unicode;
}
struct sfMouseMoveEvent
{
	sfEventType type;
	int x;
	int y;
}
struct sfMouseButtonEvent
{
	sfEventType type;
	sfMouseButton button;
	int x;
	int y;
}
struct sfMouseWheelEvent
{
	sfEventType type;
	int delta;
	int x;
	int y;
}
struct sfJoystickMoveEvent
{
	sfEventType type;
	uint joystickId;
	sfJoystickAxis axis;
	float position;
}
struct sfJoystickButtonEvent
{
	sfEventType type;
	uint joystickId;
	uint button;
}
struct sfJoystickConnectEvent
{
	sfEventType type;
	uint joystickId;
}
struct sfSizeEvent
{
	sfEventType type;
	uint width;
	uint height;
}
union sfEvent
{
	sfEventType type;
	sfSizeEvent size;
	sfKeyEvent key;
	sfTextEvent text;
	sfMouseMoveEvent mouseMove;
	sfMouseButtonEvent mouseButton;
	sfMouseWheelEvent mouseWheel;
	sfJoystickMoveEvent joystickMove;
	sfJoystickButtonEvent joystickButton;
	sfJoystickConnectEvent joystickConnect;
}
alias int sfJoystickAxis;
enum 
{
	sfJoystickX,
	sfJoystickY,
	sfJoystickZ,
	sfJoystickR,
	sfJoystickU,
	sfJoystickV,
	sfJoystickPovX,
	sfJoystickPovY,
}
enum 
{
	sfJoystickCount = 8,
	sfJoystickButtonCount = 32,
	sfJoystickAxisCount = 8,
}
alias int sfKeyCode;
enum 
{
	sfKeyA,
	sfKeyB,
	sfKeyC,
	sfKeyD,
	sfKeyE,
	sfKeyF,
	sfKeyG,
	sfKeyH,
	sfKeyI,
	sfKeyJ,
	sfKeyK,
	sfKeyL,
	sfKeyM,
	sfKeyN,
	sfKeyO,
	sfKeyP,
	sfKeyQ,
	sfKeyR,
	sfKeyS,
	sfKeyT,
	sfKeyU,
	sfKeyV,
	sfKeyW,
	sfKeyX,
	sfKeyY,
	sfKeyZ,
	sfKeyNum0,
	sfKeyNum1,
	sfKeyNum2,
	sfKeyNum3,
	sfKeyNum4,
	sfKeyNum5,
	sfKeyNum6,
	sfKeyNum7,
	sfKeyNum8,
	sfKeyNum9,
	sfKeyEscape,
	sfKeyLControl,
	sfKeyLShift,
	sfKeyLAlt,
	sfKeyLSystem,
	sfKeyRControl,
	sfKeyRShift,
	sfKeyRAlt,
	sfKeyRSystem,
	sfKeyMenu,
	sfKeyLBracket,
	sfKeyRBracket,
	sfKeySemiColon,
	sfKeyComma,
	sfKeyPeriod,
	sfKeyQuote,
	sfKeySlash,
	sfKeyBackSlash,
	sfKeyTilde,
	sfKeyEqual,
	sfKeyDash,
	sfKeySpace,
	sfKeyReturn,
	sfKeyBack,
	sfKeyTab,
	sfKeyPageUp,
	sfKeyPageDown,
	sfKeyEnd,
	sfKeyHome,
	sfKeyInsert,
	sfKeyDelete,
	sfKeyAdd,
	sfKeySubtract,
	sfKeyMultiply,
	sfKeyDivide,
	sfKeyLeft,
	sfKeyRight,
	sfKeyUp,
	sfKeyDown,
	sfKeyNumpad0,
	sfKeyNumpad1,
	sfKeyNumpad2,
	sfKeyNumpad3,
	sfKeyNumpad4,
	sfKeyNumpad5,
	sfKeyNumpad6,
	sfKeyNumpad7,
	sfKeyNumpad8,
	sfKeyNumpad9,
	sfKeyF1,
	sfKeyF2,
	sfKeyF3,
	sfKeyF4,
	sfKeyF5,
	sfKeyF6,
	sfKeyF7,
	sfKeyF8,
	sfKeyF9,
	sfKeyF10,
	sfKeyF11,
	sfKeyF12,
	sfKeyF13,
	sfKeyF14,
	sfKeyF15,
	sfKeyPause,
	sfKeyCount,
}
alias int sfMouseButton;
enum 
{
	sfMouseLeft,
	sfMouseRight,
	sfMouseMiddle,
	sfMouseXButton1,
	sfMouseXButton2,
	sfMouseButtonCount,
}
struct sfVideoMode
{
	uint width;
	uint height;
	uint bitsPerPixel;
}
enum : uint
{
	sfNone = 0,
	sfTitlebar = 1 << 0,
	sfResize = 1 << 1,
	sfClose = 1 << 2,
	sfFullscreen = 1 << 3,
	sfDefaultStyle = sfTitlebar | sfResize | sfClose,
}
struct sfContextSettings
{
	uint depthBits;
	uint stencilBits;
	uint antialiasingLevel;
	uint majorVersion;
	uint minorVersion;
}
private import derelict.util.system;

static if (Derelict_OS_Windows || Derelict_OS_Mac)
{
	alias void* sfWindowHandle;
}
else
{
	static if (Derelict_OS_Posix)
	{
		private import core.stdc.config;

		alias c_ulong sfWindowHandle;
	}
}
extern (C) nothrow 
{
	alias sfContext* function() da_sfContext_create;
	alias void function(sfContext* context) da_sfContext_destroy;
	alias void function(sfContext* context, sfBool active) da_sfContext_setActive;
	alias sfBool function(uint joystick) da_sfJoystick_isConnected;
	alias uint function(uint joystick) da_sfJoystick_getButtonCount;
	alias sfBool function(uint joystick, sfJoystickAxis axis) da_sfJoystick_hasAxis;
	alias sfBool function(uint joystick, uint button) da_sfJoystick_isButtonPressed;
	alias float function(uint joystick, sfJoystickAxis axis) da_sfJoystick_getAxisPosition;
	alias void function() da_sfJoystick_update;
	alias sfBool function(sfKeyCode key) da_sfKeyboard_isKeyPressed;
	alias sfBool function(sfMouseButton button) da_sfMouse_isButtonPressed;
	alias sfVector2i function(const(sfWindow)* relativeTo) da_sfMouse_getPosition;
	alias void function(sfVector2i position, const(sfWindow)* relativeTo) da_sfMouse_setPosition;
	alias sfVideoMode function() da_sfVideoMode_getDesktopMode;
	alias const(sfVideoMode)* function(size_t* Count) da_sfVideoMode_getFullscreenModes;
	alias sfBool function(sfVideoMode mode) da_sfVideoMode_isValid;
	alias sfWindow* function(sfVideoMode mode, const(char)* title, sfUint32 style, const(sfContextSettings)* settings) da_sfWindow_create;
	alias sfWindow* function(sfWindowHandle handle, const(sfContextSettings)* settings) da_sfWindow_createFromHandle;
	alias void function(sfWindow* window) da_sfWindow_destroy;
	alias void function(sfWindow* window) da_sfWindow_close;
	alias sfBool function(const(sfWindow)* window) da_sfWindow_isOpen;
	alias sfContextSettings function(const(sfWindow)* window) da_sfWindow_getSettings;
	alias sfBool function(sfWindow* window, sfEvent* event) da_sfWindow_pollEvent;
	alias sfBool function(sfWindow* window, sfEvent* event) da_sfWindow_waitEvent;
	alias sfVector2i function(const(sfWindow)* window) da_sfWindow_getPosition;
	alias void function(sfWindow* window, sfVector2i position) da_sfWindow_setPosition;
	alias sfVector2u function(const(sfWindow)* window) da_sfWindow_getSize;
	alias void function(sfWindow* window, sfVector2u size) da_sfWindow_setSize;
	alias void function(sfWindow* window, const(char)* title) da_sfWindow_setTitle;
	alias void function(sfWindow* window, uint width, uint height, const(sfUint8)* pixels) da_sfWindow_setIcon;
	alias void function(sfWindow* window, sfBool visible) da_sfWindow_setVisible;
	alias void function(sfWindow* window, sfBool visible) da_sfWindow_setMouseCursorVisible;
	alias void function(sfWindow* window, sfBool enabled) da_sfWindow_setVerticalSyncEnabled;
	alias void function(sfWindow* window, sfBool enabled) da_sfWindow_setKeyRepeatEnabled;
	alias sfBool function(sfWindow* window, sfBool active) da_sfWindow_setActive;
	alias void function(sfWindow* window) da_sfWindow_display;
	alias void function(sfWindow* window, uint limit) da_sfWindow_setFramerateLimit;
	alias void function(sfWindow* window, float threshold) da_sfWindow_setJoystickThreshold;
	alias sfWindowHandle function(const(sfWindow)* window) da_sfWindow_getSystemHandle;
}

__gshared 
{
	da_sfContext_create sfContext_create;
	da_sfContext_destroy sfContext_destroy;
	da_sfContext_setActive sfContext_setActive;
	da_sfJoystick_isConnected sfJoystick_isConnected;
	da_sfJoystick_getButtonCount sfJoystick_getButtonCount;
	da_sfJoystick_hasAxis sfJoystick_hasAxis;
	da_sfJoystick_isButtonPressed sfJoystick_isButtonPressed;
	da_sfJoystick_getAxisPosition sfJoystick_getAxisPosition;
	da_sfJoystick_update sfJoystick_update;
	da_sfKeyboard_isKeyPressed sfKeyboard_isKeyPressed;
	da_sfMouse_isButtonPressed sfMouse_isButtonPressed;
	da_sfMouse_getPosition sfMouse_getPosition;
	da_sfMouse_setPosition sfMouse_setPosition;
	da_sfVideoMode_getDesktopMode sfVideoMode_getDesktopMode;
	da_sfVideoMode_getFullscreenModes sfVideoMode_getFullscreenModes;
	da_sfVideoMode_isValid sfVideoMode_isValid;
	da_sfWindow_create sfWindow_create;
	da_sfWindow_createFromHandle sfWindow_createFromHandle;
	da_sfWindow_destroy sfWindow_destroy;
	da_sfWindow_close sfWindow_close;
	da_sfWindow_isOpen sfWindow_isOpen;
	da_sfWindow_getSettings sfWindow_getSettings;
	da_sfWindow_pollEvent sfWindow_pollEvent;
	da_sfWindow_waitEvent sfWindow_waitEvent;
	da_sfWindow_getPosition sfWindow_getPosition;
	da_sfWindow_setPosition sfWindow_setPosition;
	da_sfWindow_getSize sfWindow_getSize;
	da_sfWindow_setSize sfWindow_setSize;
	da_sfWindow_setTitle sfWindow_setTitle;
	da_sfWindow_setIcon sfWindow_setIcon;
	da_sfWindow_setVisible sfWindow_setVisible;
	da_sfWindow_setMouseCursorVisible sfWindow_setMouseCursorVisible;
	da_sfWindow_setVerticalSyncEnabled sfWindow_setVerticalSyncEnabled;
	da_sfWindow_setKeyRepeatEnabled sfWindow_setKeyRepeatEnabled;
	da_sfWindow_setActive sfWindow_setActive;
	da_sfWindow_display sfWindow_display;
	da_sfWindow_setFramerateLimit sfWindow_setFramerateLimit;
	da_sfWindow_setJoystickThreshold sfWindow_setJoystickThreshold;
	da_sfWindow_getSystemHandle sfWindow_getSystemHandle;
}
class DerelictSFML2WindowLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();


}
__gshared DerelictSFML2WindowLoader DerelictSFML2Window;

shared static this();
