// D import file generated from 'derelict/util/sharedlib.d'
module derelict.util.sharedlib;
private 
{
	import std.string;
	import std.conv;
	import derelict.util.exception;
	import derelict.util.system;
}
static if (Derelict_OS_Posix)
{
	static if (Derelict_OS_Linux)
	{
		private import std.c.linux.linux;

	}
	else
	{
		extern (C) nothrow 
		{
			const int RTLD_NOW = 2;

			void* dlopen(const(char)* file, int mode);
			int dlclose(void* handle);
			void* dlsym(void* handle, const(char*) name);
			const(char)* dlerror();
		}

	}
	alias void* SharedLibHandle;
	private 
	{
		SharedLibHandle LoadSharedLib(string libName);
		void UnloadSharedLib(SharedLibHandle hlib);
		void* GetSymbol(SharedLibHandle hlib, string symbolName);
		string GetErrorStr();
	}
}
else
{
	static if (Derelict_OS_Windows)
	{
		private import derelict.util.wintypes;

		alias HMODULE SharedLibHandle;
		private 
		{
			SharedLibHandle LoadSharedLib(string libName);
			void UnloadSharedLib(SharedLibHandle hlib);
			void* GetSymbol(SharedLibHandle hlib, string symbolName);
			string GetErrorStr();
		}
	}
	else
	{
		static assert(0, "Derelict does not support this platform.");
	}
}
struct SharedLib
{
	private 
	{
		string _name;
		SharedLibHandle _hlib;
		private MissingSymbolCallbackDg _onMissingSym;

	}
	public 
	{
		void load(string[] names);
		void* loadSymbol(string symbolName, bool doThrow = true);
		void unload();
		@property 
		{
			string name();
			bool isLoaded();
			void missingSymbolCallback(MissingSymbolCallbackDg callback);
			void missingSymbolCallback(MissingSymbolCallbackFunc callback);
		}
	}
}
